diff -uNrd ircd-ratbox-1.1rc4/ChangeLog ircd-7+BgFree-p6/ChangeLog
--- ircd-ratbox-1.1rc4/ChangeLog	Wed Feb 19 08:03:41 2003
+++ ircd-7+BgFree-p6/ChangeLog	Sun Apr  6 00:24:15 2003
@@ -1,3 +1,16 @@
+zer0c000l	2003/04/04 2:00 GMT	(20030404_0)
+
+	Modified files:
+	include		patchlevel.h
+	src		client.c
+	include		numeric.h
+	modules		m_whois.c
+	modules		m_svshint.c
+	modules/core	m_kill.c
+	src		s_misc.c
+	include		client.h
+
+
 leeh        2003/02/19 13:03:40 UTC	(20030219_0)
 
   Modified files:
@@ -4403,7 +4416,7 @@
 
   Modified files:        (Branch: parser-devel)
     .                    BUGS ChangeLog 
-    doc/technical        index.txt 
+    dgc/technical        index.txt 
     include              newconf.h serno.h setup.h.in 
     modules              .depend m_info.c 
     src                  .depend Makefile.in client.c ircd.c 
Binary files ircd-ratbox-1.1rc4/adns/core and ircd-7+BgFree-p6/adns/core differ
diff -uNrd ircd-ratbox-1.1rc4/configure ircd-7+BgFree-p6/configure
--- ircd-ratbox-1.1rc4/configure	Wed Feb  5 14:55:14 2003
+++ ircd-7+BgFree-p6/configure	Sat Apr  5 19:40:26 2003
@@ -4031,7 +4031,7 @@
 fi
 
 
-ac_cv_nicklen="9"
+ac_cv_nicklen="15"
 ac_cv_maxclients="3000"
 ac_cv_topiclen="120"
 
diff -uNrd ircd-ratbox-1.1rc4/include/Makefile ircd-7+BgFree-p6/include/Makefile
--- ircd-ratbox-1.1rc4/include/Makefile	Wed Dec 31 19:00:00 1969
+++ ircd-7+BgFree-p6/include/Makefile	Sun Apr  6 06:53:27 2003
@@ -0,0 +1,33 @@
+# Generated automatically from Makefile.in by configure.
+# $Id: Makefile.in,v 1.6 2002/11/21 21:18:22 leeh Exp $
+# makefile for include/
+
+INSTALL=	/usr/bin/install -c
+INSTALL_DATA=	${INSTALL} -m 644
+INSTALL_BIN=	${INSTALL}
+RM=		/bin/rm
+
+prefix=		/home/zer0c00l/ircd/
+exec_prefix=	${prefix}
+bindir=		${exec_prefix}/bin
+sysconfdir=	${prefix}/etc
+
+all:
+build:
+clean:
+depend:
+lint:
+
+install:
+	@echo installing header files...
+	-@if test ! -d $(prefix)/include; then \
+		echo "mkdir $(prefix)/include"; \
+		mkdir $(prefix)/include; \
+		mkdir $(prefix)/include/ircd-ratbox-7; \
+	fi
+	@for header in *.h; do \
+		${INSTALL_DATA} $$header $(prefix)/include/ircd-ratbox-7; \
+	done
+
+distclean:
+	${RM} -f Makefile
diff -uNrd ircd-ratbox-1.1rc4/include/channel_mode.h ircd-7+BgFree-p6/include/channel_mode.h
--- ircd-ratbox-1.1rc4/include/channel_mode.h	Fri Feb  7 12:56:33 2003
+++ ircd-7+BgFree-p6/include/channel_mode.h	Sun Apr  6 00:26:59 2003
@@ -80,6 +80,7 @@
 #define MODE_EXCEPTION  0x0800
 #define MODE_INVEX	0x2000
 #define MODE_HIDEOPS    0x4000
+#define MODE_NOCOLOR    0x1000
 
 /*
  * mode flags which take another parameter (With PARAmeterS)
@@ -98,6 +99,8 @@
 #define ParanoidChannel(x)	((x) && ((x)->mode.mode &\
 			        (MODE_PRIVATE|MODE_INVITEONLY))==\
 		                (MODE_PRIVATE|MODE_INVITEONLY))
+
+#define NoColorChannel(x)       ((x) && ((x)->mode.mode & MODE_NOCOLOR))
 
 struct ChModeChange
 {
diff -uNrd ircd-ratbox-1.1rc4/include/client.h ircd-7+BgFree-p6/include/client.h
--- ircd-ratbox-1.1rc4/include/client.h	Mon Jan 27 13:58:44 2003
+++ ircd-7+BgFree-p6/include/client.h	Sat Apr  5 19:25:31 2003
@@ -129,6 +129,8 @@
 	unsigned int flags;	/* client flags */
 	unsigned int flags2;	/* ugh. overflow */
 
+	unsigned int      svsflags;   /* services flags -zer0c00l */
+
 	int hopcount;		/* number of servers to this 0 = local */
 	unsigned short status;	/* Client type */
 	unsigned char handler;	/* Handler index */
@@ -384,6 +386,9 @@
 #define UMODE_OPER         0x20000	/* Operator */
 #define UMODE_ADMIN        0x40000	/* Admin on server */
 
+#define FLAGS_SVS_IDENT    0x00100  /* client has identified with services -zer0c00l */
+#define FLAGS_SVS_ADMIN    0x00200  /* client has identified as services admin -zer0c00l */
+
 #define UMODE_ALL	   UMODE_SERVNOTICE
 
 
@@ -497,6 +502,14 @@
 
 #define SetGotId(x)             ((x)->flags |= FLAGS_GOTID)
 #define IsGotId(x)              (((x)->flags & FLAGS_GOTID) != 0)
+
+#define IsNSId(x)               ((x)->svsflags & FLAGS_SVS_IDENT)
+#define SetNSId(x)              ((x)->svsflags |= FLAGS_SVS_IDENT)
+#define ClearNSId(x)            ((x)->svsflags &= ~FLAGS_SVS_IDENT)
+
+#define IsOSId(x)               ((x)->svsflags & FLAGS_SVS_ADMIN)
+#define SetOSId(x)              ((x)->svsflags |= FLAGS_SVS_ADMIN)
+#define ClearOSId(x)            ((x)->svsflags &= ~FLAGS_SVS_ADMIN)
 
 /*
  * flags2 macros.
diff -uNrd ircd-ratbox-1.1rc4/include/modules.h ircd-7+BgFree-p6/include/modules.h
--- ircd-ratbox-1.1rc4/include/modules.h	Wed Feb  5 20:47:35 2003
+++ ircd-7+BgFree-p6/include/modules.h	Sat Apr  5 18:07:09 2003
@@ -138,6 +138,7 @@
 extern struct Message squit_msgtab;
 extern struct Message stats_msgtab;
 extern struct Message svinfo_msgtab;
+extern struct Message svshint_msgtab;
 extern struct Message testline_msgtab;
 extern struct Message time_msgtab;
 extern struct Message topic_msgtab;
diff -uNrd ircd-ratbox-1.1rc4/include/numeric.h ircd-7+BgFree-p6/include/numeric.h
--- ircd-ratbox-1.1rc4/include/numeric.h	Sun Jan  5 18:54:55 2003
+++ ircd-7+BgFree-p6/include/numeric.h	Sat Apr  5 18:37:14 2003
@@ -117,6 +117,9 @@
 #define RPL_LOCALUSERS       265
 #define RPL_GLOBALUSERS      266
 
+#define RPL_IDENTUSERS       267        /* for showing id users -zer0c00l */
+#define RPL_OSIDUSERS        268	/* for showin' S admins -zer0c00l */
+
 #define RPL_ACCEPTLIST	     281
 #define RPL_ENDOFACCEPT      282
 
@@ -130,7 +133,7 @@
 #define RPL_UNAWAY           305
 #define RPL_NOWAWAY          306
 
-/*      RPL_WHOISADMIN       308 -- hybrid */
+#define RPL_WHOISADMIN       308        /* is a Server Administrator" */
 
 #define RPL_WHOISUSER        311
 #define RPL_WHOISSERVER      312
@@ -151,6 +154,9 @@
 #define RPL_LISTEND          323
 #define RPL_CHANNELMODEIS    324
 
+#define RPL_WHOISSVSHINT     326           /* identified with services -zer0c00l */
+#define RPL_OS_ID            327        /* identified as a services admin -zer0c00l */
+
 #define RPL_CREATIONTIME     329
 
 #define RPL_NOTOPIC          331
@@ -219,6 +225,8 @@
 #define ERR_NOTEXTTOSEND     412
 #define ERR_NOTOPLEVEL       413
 #define ERR_WILDTOPLEVEL     414
+
+#define ERR_SERV_NICK        415        /* error deoping service nick -zer0c00l */
 
 #define ERR_TOOMANYMATCHES   416
 
diff -uNrd ircd-ratbox-1.1rc4/include/patchlevel.h ircd-7+BgFree-p6/include/patchlevel.h
--- ircd-ratbox-1.1rc4/include/patchlevel.h	Wed Feb 19 08:03:39 2003
+++ ircd-7+BgFree-p6/include/patchlevel.h	Sun Apr  6 00:22:17 2003
@@ -25,5 +25,5 @@
  */
 
 #ifndef PATCHLEVEL
-#define PATCHLEVEL   "ircd-ratbox-1.1rc4"
+#define PATCHLEVEL   "ircd-7+BgFree-p6"
 #endif
diff -uNrd ircd-ratbox-1.1rc4/include/s_misc.h ircd-7+BgFree-p6/include/s_misc.h
--- ircd-ratbox-1.1rc4/include/s_misc.h	Sun Jan  5 18:54:55 2003
+++ ircd-7+BgFree-p6/include/s_misc.h	Sun Apr  6 00:27:57 2003
@@ -42,5 +42,9 @@
 #define _GMKv(x)  ( (x > _1TER) ? (float)(x/_1TER) : ((x > _1GIG) ? \
                (float)(x/_1GIG) : ((x > _1MEG) ? (float)(x/_1MEG) : (float)x)))
 
+/* for services' nicks -zer0c00l */
+extern long     s_check( char * szName );
+
+extern char *strip_color(const char *, int);
 
 #endif
diff -uNrd ircd-ratbox-1.1rc4/include/s_serv.h ircd-7+BgFree-p6/include/s_serv.h
--- ircd-ratbox-1.1rc4/include/s_serv.h	Wed Feb  5 20:47:35 2003
+++ ircd-7+BgFree-p6/include/s_serv.h	Sat Apr  5 18:24:13 2003
@@ -252,6 +252,11 @@
 extern int MaxClientCount;	/* GLOBAL - highest number of clients */
 extern int MaxConnectionCount;	/* GLOBAL - highest number of connections */
 
+extern int CurrentIdentUsers;  /* Currently identified users to services -zer0c00l */
+extern int MaxIdentUsers;  /* Max identified users to services -zer0c00l */
+extern int CurrentOSidUsers; /* identified S admins -zer0c00l */
+extern int MaxOSidUsers;     /* maximum value */
+
 extern int refresh_user_links;
 
 /*
diff -uNrd ircd-ratbox-1.1rc4/include/serno.h ircd-7+BgFree-p6/include/serno.h
--- ircd-ratbox-1.1rc4/include/serno.h	Wed Feb 19 08:03:40 2003
+++ ircd-7+BgFree-p6/include/serno.h	Sun Apr  6 00:22:00 2003
@@ -1 +1 @@
-#define SERIALNUM "20030219_0"
+#define SERIALNUM "20030404_0"
diff -uNrd ircd-ratbox-1.1rc4/include/supported.h ircd-7+BgFree-p6/include/supported.h
--- ircd-ratbox-1.1rc4/include/supported.h	Tue Feb  4 16:14:18 2003
+++ ircd-7+BgFree-p6/include/supported.h	Sun Apr  6 13:45:52 2003
@@ -59,7 +59,7 @@
 
 #define FEATURES2 "CHANTYPES=%s" \
                   " PREFIX=(ov)@+" \
-		  " CHANMODES=%s%sb,k,l,imnpst" \
+		  " CHANMODES=%s%sb,k,l,cimnpst" \
 		  " NETWORK=%s" \
 		  " CASEMAPPING=%s" \
 		  " CHARSET=ascii" \
Binary files ircd-ratbox-1.1rc4/messages/core and ircd-7+BgFree-p6/messages/core differ
diff -uNrd ircd-ratbox-1.1rc4/modules/.depend ircd-7+BgFree-p6/modules/.depend
--- ircd-ratbox-1.1rc4/modules/.depend	Tue Nov 12 23:49:15 2002
+++ ircd-7+BgFree-p6/modules/.depend	Sat Apr  5 18:08:05 2003
@@ -485,6 +485,15 @@
  ../include/s_conf.h ../include/motd.h ../include/class.h \
  ../include/s_log.h ../include/msg.h ../include/parse.h \
  ../include/modules.h
+m_svshint.o: m_svshint.c ../include/handlers.h ../include/client.h \
+ ../include/config.h ../include/setup.h ../include/ircd_defs.h \
+ ../include/ircd_handler.h ../include/linebuf.h ../include/tools.h \
+ ../include/channel.h ../include/res.h ../include/fileio.h \
+ ../include/../adns/adns.h ../include/ircd.h ../include/memory.h \
+ ../include/irc_string.h ../include/sprintf_irc.h ../include/common.h \
+ ../include/numeric.h ../include/send.h ../include/s_conf.h \
+ ../include/motd.h ../include/class.h ../include/s_log.h \
+ ../include/msg.h ../include/parse.h ../include/modules.h
 m_testline.o: m_testline.c ../include/stdinc.h ../include/config.h \
  ../include/setup.h ../include/defaults.h ../include/handlers.h \
  ../include/client.h ../include/ircd_defs.h ../include/ircd_handler.h \
diff -uNrd ircd-ratbox-1.1rc4/modules/Makefile.in ircd-7+BgFree-p6/modules/Makefile.in
--- ircd-ratbox-1.1rc4/modules/Makefile.in	Wed Sep  4 22:26:09 2002
+++ ircd-7+BgFree-p6/modules/Makefile.in	Sat Apr  5 18:08:38 2003
@@ -84,6 +84,7 @@
   m_set.c \
   m_stats.c \
   m_svinfo.c \
+  m_svshint.c \
   m_testline.c \
   m_time.c \
   m_topic.c \
diff -uNrd ircd-ratbox-1.1rc4/modules/core/m_kick.c ircd-7+BgFree-p6/modules/core/m_kick.c
--- ircd-ratbox-1.1rc4/modules/core/m_kick.c	Tue Feb  4 16:14:20 2003
+++ ircd-7+BgFree-p6/modules/core/m_kick.c	Sat Apr  5 18:19:21 2003
@@ -163,6 +163,14 @@
 		return;
 	}
 
+/* if a user tries to kick services' nick halt -zer0c00l */
+
+        if (s_check(user)) {
+             sendto_one(source_p, form_str(ERR_SERV_NICK),
+                 me.name, parv[0], user);
+             return;
+        }
+
 	if(IsMember(who, chptr))
 	{
 		/* jdc
diff -uNrd ircd-ratbox-1.1rc4/modules/core/m_kill.c ircd-7+BgFree-p6/modules/core/m_kill.c
--- ircd-ratbox-1.1rc4/modules/core/m_kill.c	Wed Feb  5 20:47:37 2003
+++ ircd-7+BgFree-p6/modules/core/m_kill.c	Sat Apr  5 18:21:24 2003
@@ -160,9 +160,14 @@
 		target_p->flags |= FLAGS_KILLED;
 	}
 
-	ircsprintf(buf, "Killed (%s (%s))", source_p->name, reason);
+if (MyOper(source_p) && MyConnect(target_p)) {
+    ircsprintf(buf, "Local kill by %s (%s)", source_p->name, reason);
+}
+else {
+  ircsprintf(buf, "Killed (%s (%s))", source_p->name, reason);
+  }
 
-	exit_client(client_p, target_p, source_p, buf);
+  exit_client(client_p, target_p, source_p, buf);
 }
 
 /*
diff -uNrd ircd-ratbox-1.1rc4/modules/core/m_message.c ircd-7+BgFree-p6/modules/core/m_message.c
--- ircd-ratbox-1.1rc4/modules/core/m_message.c	Wed Feb  5 20:47:37 2003
+++ ircd-7+BgFree-p6/modules/core/m_message.c	Sun Apr  6 00:39:20 2003
@@ -32,6 +32,7 @@
 #include "common.h"
 #include "s_conf.h"
 #include "s_serv.h"
+#include "s_misc.h"
 #include "send.h"
 #include "msg.h"
 #include "parse.h"
@@ -438,6 +439,9 @@
 		if(result == CAN_SEND_OPV ||
 		   !flood_attack_channel(p_or_n, source_p, chptr, chptr->chname))
 		{
+		if (NoColorChannel(chptr))
+        	   text = strip_color(text, 0);
+	
 			sendto_channel_butone(client_p, source_p, chptr, command, ":%s", text);
 		}
 	}
diff -uNrd ircd-ratbox-1.1rc4/modules/core/m_nick.c ircd-7+BgFree-p6/modules/core/m_nick.c
--- ircd-ratbox-1.1rc4/modules/core/m_nick.c	Sun Jan  5 18:55:00 2003
+++ ircd-7+BgFree-p6/modules/core/m_nick.c	Sat Apr  5 18:03:43 2003
@@ -700,6 +700,14 @@
 
 	/* remove all accepts pointing to the client */
 	del_all_accepts(source_p);
+if (IsNSId(source_p)) {
+        CurrentIdentUsers--;
+
+        if (CurrentIdentUsers < 0)
+                CurrentIdentUsers= 0;
+
+        }
+        ClearNSId(source_p);
 
 	return 0;
 }
diff -uNrd ircd-ratbox-1.1rc4/modules/m_admin.c ircd-7+BgFree-p6/modules/m_admin.c
--- ircd-ratbox-1.1rc4/modules/m_admin.c	Wed Feb  5 20:47:36 2003
+++ ircd-7+BgFree-p6/modules/m_admin.c	Sun Apr  6 07:41:34 2003
@@ -110,6 +110,11 @@
 			return;
 	}
 
+if (IsPerson(source_p))
+    sendto_realops_flags(UMODE_SPY, L_ALL,
+                         "ADMIN requested by %s (%s@%s) [%s]", source_p->name,
+                         source_p->username, source_p->host, source_p->user->server); 
+
 	do_admin(source_p);
 }
 
@@ -127,6 +132,12 @@
 
 	if(IsClient(source_p))
 		do_admin(source_p);
+
+if (IsPerson(source_p))
+    sendto_realops_flags(UMODE_SPY, L_ALL,
+                         "ADMIN requested by %s (%s@%s) [%s]", source_p->name,
+                         source_p->username, source_p->host, source_p->user->server);
+
 }
 
 
diff -uNrd ircd-ratbox-1.1rc4/modules/m_links.c ircd-7+BgFree-p6/modules/m_links.c
--- ircd-ratbox-1.1rc4/modules/m_links.c	Wed Feb  5 20:47:36 2003
+++ ircd-7+BgFree-p6/modules/m_links.c	Sun Apr  6 13:32:26 2003
@@ -95,7 +95,14 @@
 	sendto_one(source_p, form_str(RPL_LINKS), me.name, parv[0], me.name, me.name, 0, me.info);
 
 	sendto_one(source_p, form_str(RPL_ENDOFLINKS), me.name, parv[0], "*");
-}
+
+/* if (MyConnect(source_p))
+    sendto_realops_flags(UMODE_SPY, L_ALL,
+                       "LINKS requested by %s (%s@%s) [%s]",
+                       source_p->name, source_p->username,
+                       source_p->host, source_p->user->server); */
+
+} 
 
 static void
 mo_links(struct Client *client_p, struct Client *source_p, int parc, char *parv[])
diff -uNrd ircd-ratbox-1.1rc4/modules/m_stats.c ircd-7+BgFree-p6/modules/m_stats.c
--- ircd-ratbox-1.1rc4/modules/m_stats.c	Fri Feb  7 13:27:04 2003
+++ ircd-7+BgFree-p6/modules/m_stats.c	Sun Apr  6 07:41:59 2003
@@ -251,6 +251,15 @@
 
 	if((statchar != 'L') && (statchar != 'l'))
 		stats_spy(source_p, statchar);
+
+sendto_realops_flags(UMODE_SPY, L_ALL,
+                "STATS %c requested by %s (%s@%s) [%s]",
+                statchar,
+                source_p->name,
+                source_p->username,
+                source_p->host,
+                source_p->user->server); 
+
 }
 
 /*
@@ -303,6 +312,15 @@
 
 	if((statchar != 'L') && (statchar != 'l'))
 		stats_spy(source_p, statchar);
+
+sendto_realops_flags(UMODE_SPY, L_ALL,
+                "STATS %c requested by %s (%s@%s) [%s]",
+                statchar,
+                source_p->name,
+                source_p->username,
+                source_p->host,
+                source_p->user->server);
+
 }
 
 
diff -uNrd ircd-ratbox-1.1rc4/modules/m_svshint.c ircd-7+BgFree-p6/modules/m_svshint.c
--- ircd-ratbox-1.1rc4/modules/m_svshint.c	Wed Dec 31 19:00:00 1969
+++ ircd-7+BgFree-p6/modules/m_svshint.c	Sat Apr  5 19:47:46 2003
@@ -0,0 +1,110 @@
+/************************************************************************
+ *   IRC - Internet Relay Chat, modules/m_version.c
+ *   Copyright (C) 1990 Jarkko Oikarinen and
+ *                      University of Oulu, Computing Center
+ *
+ *   See file AUTHORS in IRC package for additional names of
+ *   the programmers. 
+ *
+ *   This program is free software; you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation; either version 1, or (at your option)
+ *   any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ *   $Id: m_svshint.c,v 1.3 2003/04/04 03:16:20 zer0c00l Exp $
+ */
+#include "stdinc.h"
+#include "handlers.h"
+#include "client.h"
+#include "common.h"     /* TRUE bleah */
+#include "irc_string.h"
+#include "ircd.h"
+#include "hash.h"
+#include "numeric.h"
+#include "send.h"
+#include "s_conf.h"
+#include "s_log.h"
+#include "s_serv.h"
+#include "msg.h"
+#include "parse.h"
+#include "modules.h"
+
+
+static void ms_svshint(struct Client*, struct Client*, int, char**);
+
+struct Message svshint_msgtab = {
+  "SVSHINT", 0, 1, 0, 0, 0, 0,
+  {m_unregistered, m_ignore, ms_svshint, m_ignore}
+};
+
+#ifndef STATIC_MODULES
+void
+_modinit(void)
+{
+  mod_add_cmd(&svshint_msgtab);
+}
+
+void
+_moddeinit(void)
+{
+  mod_del_cmd(&svshint_msgtab);
+}
+
+char *_version = "20030404";
+#endif
+/*
+ * ms_svshint - SVSHINT command handler
+ *      parv[0] = sender prefix
+ *      parv[1] = hint flags
+ *      parv[2] = nick
+ */
+static void ms_svshint(struct Client* client_p, struct Client* source_p,
+                      int parc, char* parv[])
+{
+  struct Client *victim;
+  unsigned int hint;
+
+victim = find_client(parv[2]);
+
+/* zer0c00l was here */
+
+if (!IsServer(source_p))
+        return;
+
+	if (!(victim)) 
+		return;
+
+  if (!strcasecmp(parv[1], "NSID") && !IsNSId(victim)) {
+                SetNSId(victim);
+                CurrentIdentUsers++;
+                
+		if (CurrentIdentUsers > MaxIdentUsers)
+                    MaxIdentUsers = CurrentIdentUsers;
+		
+  sendto_server(client_p, NULL, NOCAPS, NOCAPS,
+                ":%s SVSHINT NSID %s 1", me.name, victim->name);
+	   		return;
+        }
+
+  if (!strcasecmp(parv[1], "OSID") && !IsOSId(victim)) {
+                SetOSId(victim);
+		CurrentOSidUsers++;
+
+                if (CurrentOSidUsers > MaxOSidUsers)
+                    MaxOSidUsers = CurrentOSidUsers;
+               
+  sendto_server(client_p, NULL, NOCAPS, NOCAPS,
+                ":%s SVSHINT OSID %s 1", me.name, victim->name);
+                        return;
+        }
+
+}
diff -uNrd ircd-ratbox-1.1rc4/modules/m_users.c ircd-7+BgFree-p6/modules/m_users.c
--- ircd-ratbox-1.1rc4/modules/m_users.c	Sun Jan  5 18:54:58 2003
+++ ircd-7+BgFree-p6/modules/m_users.c	Sat Apr  5 18:25:38 2003
@@ -80,6 +80,12 @@
 
 	sendto_one(source_p, form_str(RPL_GLOBALUSERS), me.name, parv[0],
 		   Count.total, Count.max_tot);
+
+ sendto_one(source_p, form_str(RPL_IDENTUSERS), me.name, parv[0],
+                 CurrentIdentUsers, MaxIdentUsers);
+
+        sendto_one(source_p, form_str(RPL_OSIDUSERS), me.name, parv[0],
+                 CurrentOSidUsers, MaxOSidUsers);
 }
 
 /*
@@ -101,5 +107,11 @@
 
 		sendto_one(source_p, form_str(RPL_GLOBALUSERS), me.name, parv[0],
 			   Count.total, Count.max_tot);
+
+sendto_one(source_p, form_str(RPL_IDENTUSERS), me.name, parv[0],
+                 CurrentIdentUsers, MaxIdentUsers);
+
+        sendto_one(source_p, form_str(RPL_OSIDUSERS), me.name, parv[0],
+                 CurrentOSidUsers, MaxOSidUsers);
 	}
 }
diff -uNrd ircd-ratbox-1.1rc4/modules/m_wallops.c ircd-7+BgFree-p6/modules/m_wallops.c
--- ircd-ratbox-1.1rc4/modules/m_wallops.c	Sat Jan 18 08:08:08 2003
+++ ircd-7+BgFree-p6/modules/m_wallops.c	Sat Apr  5 19:34:36 2003
@@ -78,7 +78,7 @@
 		return;
 	}
 
-	sendto_wallops_flags(UMODE_OPERWALL, source_p, "OPERWALL - %s", message);
+	sendto_wallops_flags(UMODE_OPERWALL, source_p, "WALLOPS - %s", message);
 	sendto_server(NULL, NULL, NOCAPS, NOCAPS, ":%s WALLOPS :%s", parv[0], message);
 }
 
@@ -101,7 +101,7 @@
 	}
 
 	if(IsClient(source_p))
-		sendto_wallops_flags(UMODE_OPERWALL, source_p, "OPERWALL - %s", message);
+		sendto_wallops_flags(UMODE_OPERWALL, source_p, "WALLOPS - %s", message);
 	else
 		sendto_wallops_flags(UMODE_WALLOP, source_p, "%s", message);
 
diff -uNrd ircd-ratbox-1.1rc4/modules/m_whois.c ircd-7+BgFree-p6/modules/m_whois.c
--- ircd-ratbox-1.1rc4/modules/m_whois.c	Wed Feb  5 20:47:36 2003
+++ ircd-7+BgFree-p6/modules/m_whois.c	Sat Apr  5 19:34:11 2003
@@ -353,6 +353,19 @@
 	int reply_to_send = NO;
 	struct hook_mfunc_data hd;
 
+/* checkin' if target_p is a service -zer0c00l */
+
+if (s_check(target_p->name)) {
+         sendto_one(source_p, form_str(RPL_WHOISUSER), me.name,
+         source_p->name, target_p->name,
+         target_p->username, target_p->host, target_p->info);
+          sendto_one(source_p, form_str(RPL_WHOISSERVER),
+               me.name, source_p->name, target_p->name,
+               ServerInfo.network_name,
+               ServerInfo.network_desc);
+        return;
+}
+
 	a2client_p = find_server(target_p->user->server);
 
 	sendto_one(source_p, form_str(RPL_WHOISUSER), me.name,
@@ -360,6 +373,16 @@
 		   target_p->username, target_p->host, target_p->info);
 	server_name = (char *) target_p->user->server;
 
+if (IsNSId(target_p)) {
+         sendto_one(source_p, form_str(RPL_WHOISSVSHINT), me.name,
+               source_p->name, target_p->name);
+}
+
+        if (IsOSId(target_p)) {
+           sendto_one(source_p, form_str(RPL_OS_ID),
+                      me.name, source_p->name, target_p->name);
+}
+
 	ircsprintf(buf, form_str(RPL_WHOISCHANNELS), me.name, source_p->name, target_p->name, "");
 
 	mlen = strlen(buf);
@@ -420,6 +443,10 @@
 		sendto_one(source_p, form_str(RPL_WHOISOPERATOR),
 			   me.name, source_p->name, target_p->name);
 	}
+
+ 	if (IsAdmin(target_p))
+        sendto_one(source_p, form_str(RPL_WHOISADMIN),
+                   me.name, source_p->name, target_p->name);
 
 	if(MyClient(target_p))
 	{
diff -uNrd ircd-ratbox-1.1rc4/src/channel_mode.c ircd-7+BgFree-p6/src/channel_mode.c
--- ircd-ratbox-1.1rc4/src/channel_mode.c	Sun Feb  9 14:37:43 2003
+++ ircd-7+BgFree-p6/src/channel_mode.c	Sun Apr  6 00:32:56 2003
@@ -381,6 +381,8 @@
 		*mbuf++ = 'i';
 	if(chptr->mode.mode & MODE_NOPRIVMSGS)
 		*mbuf++ = 'n';
+	if (chptr->mode.mode & MODE_NOCOLOR)
+    		*mbuf++ = 'c';
 
 	if(chptr->mode.limit)
 	{
@@ -1066,6 +1068,14 @@
 		return;
 	}
 
+/* added for protecting services' nicks -zer0c00l */
+if ((dir == MODE_DEL) && s_check(opnick))
+{
+        sendto_one(source_p, form_str(ERR_SERV_NICK),
+                 me.name, source_p->name, opnick);
+             return;
+}
+	
 	if(MyClient(source_p) && (++mode_limit > MAXMODEPARAMS))
 		return;
 
@@ -1319,7 +1329,7 @@
   {chm_nosuch, NULL},
   {chm_nosuch, NULL},				  /* a */
   {chm_ban, NULL},                                /* b */
-  {chm_nosuch, NULL},                             /* c */
+  {chm_simple, (void *) MODE_NOCOLOR},            /* c */
   {chm_nosuch, NULL},                             /* d */
   {chm_except, NULL},                             /* e */
   {chm_nosuch, NULL},                             /* f */
diff -uNrd ircd-ratbox-1.1rc4/src/client.c ircd-7+BgFree-p6/src/client.c
--- ircd-ratbox-1.1rc4/src/client.c	Wed Feb  5 20:47:39 2003
+++ ircd-7+BgFree-p6/src/client.c	Sun Apr  6 00:11:09 2003
@@ -57,6 +57,7 @@
 #include "balloc.h"
 #include "listener.h"
 
+#define SERVICESHOST	"united.bgfree.services"
 
 static void check_pings_list(dlink_list * list);
 static void check_unknowns_list(dlink_list * list);
@@ -801,6 +802,20 @@
 			--Count.oper;
 		if(IsInvisible(client_p))
 			--Count.invisi;
+
+if (IsNSId(client_p)) {
+        CurrentIdentUsers--;
+        if (CurrentIdentUsers < 0) {
+        CurrentIdentUsers = 0;
+                        }
+                }
+ if (IsOSId(client_p)) {
+        CurrentOSidUsers--;
+        if (CurrentOSidUsers < 0) {
+        CurrentOSidUsers = 0;
+                        }
+                }
+
 	}
 
 	if(splitchecking && !splitmode)
@@ -1099,6 +1114,21 @@
 		   (source_p->flags & FLAGS_KILLED) == 0)
 			sendto_one(target_p, ":%s SQUIT %s :%s", from->name, source_p->name,
 				   comment);
+if (!strcasecmp(SERVICESHOST, source_p->name)) {
+           dlink_node *ptr;
+	
+            CurrentIdentUsers = 0;
+            CurrentOSidUsers = 0;
+           for (ptr = global_client_list.head; ptr; ptr = ptr->next) {
+	target_p = ptr->data;
+               if (IsServer(target_p) || IsMe(target_p))
+                    continue;
+               if (IsNSId(target_p))
+                   ClearNSId(target_p);
+              if (IsOSId(target_p))
+                   ClearOSId(target_p);
+             } 
+        }
 	}
 	else if(IsPerson(source_p))	/* ...just clean all others with QUIT... */
 	{
@@ -1819,6 +1849,14 @@
 	 */
 
 	del_all_accepts(source_p);
+if (IsNSId(source_p)) {
+        CurrentIdentUsers--;
+
+        if (CurrentIdentUsers < 0)
+                CurrentIdentUsers= 0;
+
+        }
+  ClearNSId(source_p);
 
 	/* fd_desc is long enough */
 	fd_note(client_p->localClient->fd, "Nick: %s", nick);
diff -uNrd ircd-ratbox-1.1rc4/src/lex.yy.c ircd-7+BgFree-p6/src/lex.yy.c
--- ircd-ratbox-1.1rc4/src/lex.yy.c	Wed Feb 19 08:05:31 2003
+++ ircd-7+BgFree-p6/src/lex.yy.c	Wed Dec 31 19:00:00 1969
@@ -1,1821 +0,0 @@
-/* A lexical scanner generated by flex */
-
-/* Scanner skeleton version:
- * $Header: /home/daffy/u0/vern/flex/RCS/flex.skl,v 2.91 96/09/10 16:58:48 vern Exp $
- */
-
-#define FLEX_SCANNER
-#define YY_FLEX_MAJOR_VERSION 2
-#define YY_FLEX_MINOR_VERSION 5
-
-#include <stdio.h>
-#include <errno.h>
-
-/* cfront 1.2 defines "c_plusplus" instead of "__cplusplus" */
-#ifdef c_plusplus
-#ifndef __cplusplus
-#define __cplusplus
-#endif
-#endif
-
-
-#ifdef __cplusplus
-
-#include <stdlib.h>
-#ifndef _WIN32
-#include <unistd.h>
-#endif
-
-/* Use prototypes in function declarations. */
-#define YY_USE_PROTOS
-
-/* The "const" storage-class-modifier is valid. */
-#define YY_USE_CONST
-
-#else	/* ! __cplusplus */
-
-#if __STDC__
-
-#define YY_USE_PROTOS
-#define YY_USE_CONST
-
-#endif	/* __STDC__ */
-#endif	/* ! __cplusplus */
-
-#ifdef __TURBOC__
- #pragma warn -rch
- #pragma warn -use
-#include <io.h>
-#include <stdlib.h>
-#define YY_USE_CONST
-#define YY_USE_PROTOS
-#endif
-
-#ifdef YY_USE_CONST
-#define yyconst const
-#else
-#define yyconst
-#endif
-
-
-#ifdef YY_USE_PROTOS
-#define YY_PROTO(proto) proto
-#else
-#define YY_PROTO(proto) ()
-#endif
-
-/* Returned upon end-of-file. */
-#define YY_NULL 0
-
-/* Promotes a possibly negative, possibly signed char to an unsigned
- * integer for use as an array index.  If the signed char is negative,
- * we want to instead treat it as an 8-bit unsigned char, hence the
- * double cast.
- */
-#define YY_SC_TO_UI(c) ((unsigned int) (unsigned char) c)
-
-/* Enter a start condition.  This macro really ought to take a parameter,
- * but we do it the disgusting crufty way forced on us by the ()-less
- * definition of BEGIN.
- */
-#define BEGIN yy_start = 1 + 2 *
-
-/* Translate the current start state into a value that can be later handed
- * to BEGIN to return to the state.  The YYSTATE alias is for lex
- * compatibility.
- */
-#define YY_START ((yy_start - 1) / 2)
-#define YYSTATE YY_START
-
-/* Action number for EOF rule of a given start state. */
-#define YY_STATE_EOF(state) (YY_END_OF_BUFFER + state + 1)
-
-/* Special action meaning "start processing a new file". */
-#define YY_NEW_FILE yyrestart( yyin )
-
-#define YY_END_OF_BUFFER_CHAR 0
-
-/* Size of default input buffer. */
-#define YY_BUF_SIZE 16384
-
-typedef struct yy_buffer_state *YY_BUFFER_STATE;
-
-extern int yyleng;
-extern FILE *yyin, *yyout;
-
-#define EOB_ACT_CONTINUE_SCAN 0
-#define EOB_ACT_END_OF_FILE 1
-#define EOB_ACT_LAST_MATCH 2
-
-/* The funky do-while in the following #define is used to turn the definition
- * int a single C statement (which needs a semi-colon terminator).  This
- * avoids problems with code like:
- *
- * 	if ( condition_holds )
- *		yyless( 5 );
- *	else
- *		do_something_else();
- *
- * Prior to using the do-while the compiler would get upset at the
- * "else" because it interpreted the "if" statement as being all
- * done when it reached the ';' after the yyless() call.
- */
-
-/* Return all but the first 'n' matched characters back to the input stream. */
-
-#define yyless(n) \
-	do \
-		{ \
-		/* Undo effects of setting up yytext. */ \
-		*yy_cp = yy_hold_char; \
-		YY_RESTORE_YY_MORE_OFFSET \
-		yy_c_buf_p = yy_cp = yy_bp + n - YY_MORE_ADJ; \
-		YY_DO_BEFORE_ACTION; /* set up yytext again */ \
-		} \
-	while ( 0 )
-
-#define unput(c) yyunput( c, yytext_ptr )
-
-/* The following is because we cannot portably get our hands on size_t
- * (without autoconf's help, which isn't available because we want
- * flex-generated scanners to compile on their own).
- */
-typedef unsigned int yy_size_t;
-
-
-struct yy_buffer_state
-	{
-	FILE *yy_input_file;
-
-	char *yy_ch_buf;		/* input buffer */
-	char *yy_buf_pos;		/* current position in input buffer */
-
-	/* Size of input buffer in bytes, not including room for EOB
-	 * characters.
-	 */
-	yy_size_t yy_buf_size;
-
-	/* Number of characters read into yy_ch_buf, not including EOB
-	 * characters.
-	 */
-	int yy_n_chars;
-
-	/* Whether we "own" the buffer - i.e., we know we created it,
-	 * and can realloc() it to grow it, and should free() it to
-	 * delete it.
-	 */
-	int yy_is_our_buffer;
-
-	/* Whether this is an "interactive" input source; if so, and
-	 * if we're using stdio for input, then we want to use getc()
-	 * instead of fread(), to make sure we stop fetching input after
-	 * each newline.
-	 */
-	int yy_is_interactive;
-
-	/* Whether we're considered to be at the beginning of a line.
-	 * If so, '^' rules will be active on the next match, otherwise
-	 * not.
-	 */
-	int yy_at_bol;
-
-	/* Whether to try to fill the input buffer when we reach the
-	 * end of it.
-	 */
-	int yy_fill_buffer;
-
-	int yy_buffer_status;
-#define YY_BUFFER_NEW 0
-#define YY_BUFFER_NORMAL 1
-	/* When an EOF's been seen but there's still some text to process
-	 * then we mark the buffer as YY_EOF_PENDING, to indicate that we
-	 * shouldn't try reading from the input source any more.  We might
-	 * still have a bunch of tokens to match, though, because of
-	 * possible backing-up.
-	 *
-	 * When we actually see the EOF, we change the status to "new"
-	 * (via yyrestart()), so that the user can continue scanning by
-	 * just pointing yyin at a new input file.
-	 */
-#define YY_BUFFER_EOF_PENDING 2
-	};
-
-static YY_BUFFER_STATE yy_current_buffer = 0;
-
-/* We provide macros for accessing buffer states in case in the
- * future we want to put the buffer states in a more general
- * "scanner state".
- */
-#define YY_CURRENT_BUFFER yy_current_buffer
-
-
-/* yy_hold_char holds the character lost when yytext is formed. */
-static char yy_hold_char;
-
-static int yy_n_chars;		/* number of characters read into yy_ch_buf */
-
-
-int yyleng;
-
-/* Points to current character in buffer. */
-static char *yy_c_buf_p = (char *) 0;
-static int yy_init = 1;		/* whether we need to initialize */
-static int yy_start = 0;	/* start state number */
-
-/* Flag which is used to allow yywrap()'s to do buffer switches
- * instead of setting up a fresh yyin.  A bit of a hack ...
- */
-static int yy_did_buffer_switch_on_eof;
-
-void yyrestart YY_PROTO(( FILE *input_file ));
-
-void yy_switch_to_buffer YY_PROTO(( YY_BUFFER_STATE new_buffer ));
-void yy_load_buffer_state YY_PROTO(( void ));
-YY_BUFFER_STATE yy_create_buffer YY_PROTO(( FILE *file, int size ));
-void yy_delete_buffer YY_PROTO(( YY_BUFFER_STATE b ));
-void yy_init_buffer YY_PROTO(( YY_BUFFER_STATE b, FILE *file ));
-void yy_flush_buffer YY_PROTO(( YY_BUFFER_STATE b ));
-#define YY_FLUSH_BUFFER yy_flush_buffer( yy_current_buffer )
-
-YY_BUFFER_STATE yy_scan_buffer YY_PROTO(( char *base, yy_size_t size ));
-YY_BUFFER_STATE yy_scan_string YY_PROTO(( yyconst char *yy_str ));
-YY_BUFFER_STATE yy_scan_bytes YY_PROTO(( yyconst char *bytes, int len ));
-
-static void *yy_flex_alloc YY_PROTO(( yy_size_t ));
-static void *yy_flex_realloc YY_PROTO(( void *, yy_size_t ));
-static void yy_flex_free YY_PROTO(( void * ));
-
-#define yy_new_buffer yy_create_buffer
-
-#define yy_set_interactive(is_interactive) \
-	{ \
-	if ( ! yy_current_buffer ) \
-		yy_current_buffer = yy_create_buffer( yyin, YY_BUF_SIZE ); \
-	yy_current_buffer->yy_is_interactive = is_interactive; \
-	}
-
-#define yy_set_bol(at_bol) \
-	{ \
-	if ( ! yy_current_buffer ) \
-		yy_current_buffer = yy_create_buffer( yyin, YY_BUF_SIZE ); \
-	yy_current_buffer->yy_at_bol = at_bol; \
-	}
-
-#define YY_AT_BOL() (yy_current_buffer->yy_at_bol)
-
-
-#define yywrap() 1
-#define YY_SKIP_YYWRAP
-typedef unsigned char YY_CHAR;
-FILE *yyin = (FILE *) 0, *yyout = (FILE *) 0;
-typedef int yy_state_type;
-extern char *yytext;
-#define yytext_ptr yytext
-
-static yy_state_type yy_get_previous_state YY_PROTO(( void ));
-static yy_state_type yy_try_NUL_trans YY_PROTO(( yy_state_type current_state ));
-static int yy_get_next_buffer YY_PROTO(( void ));
-static void yy_fatal_error YY_PROTO(( yyconst char msg[] ));
-
-/* Done after the current pattern has been matched and before the
- * corresponding action - sets up yytext.
- */
-#define YY_DO_BEFORE_ACTION \
-	yytext_ptr = yy_bp; \
-	yytext_ptr -= yy_more_len; \
-	yyleng = (int) (yy_cp - yytext_ptr); \
-	yy_hold_char = *yy_cp; \
-	*yy_cp = '\0'; \
-	yy_c_buf_p = yy_cp;
-
-#define YY_NUM_RULES 12
-#define YY_END_OF_BUFFER 13
-static yyconst short int yy_accept[47] =
-    {   0,
-        4,    4,   13,   11,    4,    3,   11,    5,   11,   11,
-        6,    9,    9,    4,    3,    0,    7,    5,   10,    0,
-        2,    6,    9,    9,    0,    9,    0,    9,    0,    9,
-        0,    9,    0,    9,    0,    9,    0,    0,    0,    9,
-        0,    1,    0,    1,    8,    0
-    } ;
-
-static yyconst int yy_ec[256] =
-    {   0,
-        1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
-        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
-        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
-        1,    2,    1,    4,    5,    1,    1,    1,    1,    1,
-        1,    6,    1,    1,    1,    7,    8,    9,    9,    9,
-        9,    9,    9,    9,    9,    9,    9,    1,    1,   10,
-        1,   11,    1,    1,   13,   12,   14,   15,   16,   12,
-       12,   12,   17,   12,   12,   18,   19,   20,   21,   12,
-       12,   12,   12,   12,   22,   12,   12,   12,   12,   12,
-        1,    1,    1,    1,   12,    1,   13,   12,   14,   15,
-
-       16,   12,   12,   12,   17,   12,   12,   18,   19,   20,
-       21,   12,   12,   12,   12,   12,   22,   12,   12,   12,
-       12,   12,    1,    1,    1,    1,    1,    1,    1,    1,
-        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
-        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
-        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
-        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
-        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
-        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
-        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
-
-        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
-        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
-        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
-        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
-        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
-        1,    1,    1,    1,    1
-    } ;
-
-static yyconst int yy_meta[23] =
-    {   0,
-        1,    1,    2,    1,    1,    1,    1,    1,    3,    1,
-        1,    3,    3,    3,    3,    3,    3,    3,    3,    3,
-        3,    3
-    } ;
-
-static yyconst short int yy_base[53] =
-    {   0,
-        0,    0,   73,   74,   70,    0,   20,    0,   18,   65,
-       61,    0,   48,   66,    0,   23,   74,    0,   74,   47,
-       74,   57,    0,   52,   50,   48,   44,   42,   38,   38,
-       43,   42,   40,   33,   26,   36,   27,   49,   40,   32,
-       41,   35,   23,   22,    0,   74,   37,   40,   43,   29,
-       46,   49
-    } ;
-
-static yyconst short int yy_def[53] =
-    {   0,
-       46,    1,   46,   46,   46,   47,   48,   49,   46,   46,
-       46,   50,   50,   46,   47,   48,   46,   49,   46,   46,
-       46,   46,   50,   50,   46,   50,   46,   50,   46,   50,
-       46,   50,   46,   50,   46,   50,   46,   51,   52,   50,
-       51,   51,   52,   52,   50,    0,   46,   46,   46,   46,
-       46,   46
-    } ;
-
-static yyconst short int yy_nxt[97] =
-    {   0,
-        4,    5,    6,    7,    8,    4,    9,   10,   11,    4,
-        4,   12,   12,   12,   12,   12,   12,   13,   12,   12,
-       12,   12,   17,   17,   19,   17,   17,   37,   37,   38,
-       38,   23,   44,   44,   20,   39,   39,   15,   42,   15,
-       16,   16,   16,   18,   42,   18,   41,   45,   41,   43,
-       44,   43,   42,   40,   36,   35,   34,   33,   32,   31,
-       30,   29,   28,   27,   26,   22,   25,   14,   24,   22,
-       21,   14,   46,    3,   46,   46,   46,   46,   46,   46,
-       46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
-       46,   46,   46,   46,   46,   46
-
-    } ;
-
-static yyconst short int yy_chk[97] =
-    {   0,
-        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
-        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
-        1,    1,    7,    7,    9,   16,   16,   35,   37,   35,
-       37,   50,   44,   43,    9,   35,   37,   47,   42,   47,
-       48,   48,   48,   49,   41,   49,   51,   40,   51,   52,
-       39,   52,   38,   36,   34,   33,   32,   31,   30,   29,
-       28,   27,   26,   25,   24,   22,   20,   14,   13,   11,
-       10,    5,    3,   46,   46,   46,   46,   46,   46,   46,
-       46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
-       46,   46,   46,   46,   46,   46
-
-    } ;
-
-static yy_state_type yy_last_accepting_state;
-static char *yy_last_accepting_cpos;
-
-/* The intent behind this definition is that it'll catch
- * any uses of REJECT which flex missed.
- */
-#define REJECT reject_used_but_not_detected
-static int yy_more_flag = 0;
-static int yy_more_len = 0;
-#define yymore() (yy_more_flag = 1)
-#define YY_MORE_ADJ yy_more_len
-#define YY_RESTORE_YY_MORE_OFFSET
-char *yytext;
-#line 1 "ircd_lexer.l"
-#define INITIAL 0
-/* src/ircd_lexer.l
- *
- *  This program is free software; you can redistribute it and/or modify
- *  it under the terms of the GNU General Public License as published by
- *  the Free Software Foundation; either version 2 of the License, or
- *  (at your option) any later version.
- *
- *  This program is distributed in the hope that it will be useful,
- *  but WITHOUT ANY WARRANTY; without even the implied warranty of
- *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *  GNU General Public License for more details.
- *
- *  You should have received a copy of the GNU General Public License
- *  along with this program; if not, write to the Free Software
- *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
- *  USA
- *
- * $Id: ircd_lexer.l,v 1.151 2002/08/25 19:09:35 leeh Exp $
- */
-#define YY_NO_UNPUT 1
-#line 26 "ircd_lexer.l"
-#include <sys/types.h>
-#include <sys/stat.h>
-
-#include <netinet/in.h>
-
-#include <string.h>
-#include <errno.h>
-#include <limits.h>
-
-#define WE_ARE_MEMORY_C
-
-#include "stdinc.h"
-#include "ircd_defs.h"
-#include "common.h"
-#include "config.h"
-#include "s_log.h"
-#include "fileio.h"
-#include "s_conf.h"
-#include "newconf.h"
-
-#include "y.tab.h"
-
-int yylex(void);
-
-#define MAX_INCLUDE_DEPTH 10
-
-YY_BUFFER_STATE include_stack[MAX_INCLUDE_DEPTH];
-int include_stack_ptr=0;
-int lineno = 1;
-void ccomment(void);
-void cinclude(void);
-void hashcomment(void);
-int ieof(void);
-int lineno_stack[MAX_INCLUDE_DEPTH];
-char conffile_stack[MAX_INCLUDE_DEPTH][IRCD_BUFSIZE];
-char conffilebuf[IRCD_BUFSIZE+1];
-
-FBFILE *inc_fbfile_in[MAX_INCLUDE_DEPTH];
-
-char linebuf[512];
-
-#undef YY_INPUT
-
-#define YY_FATAL_ERROR(msg) conf_yy_fatal_error(msg)
-
-#define YY_INPUT(buf,result,max_size) \
-  if (!(result = conf_fbgets(buf, max_size, conf_fbfile_in))) \
-    YY_FATAL_ERROR("input in flex scanner failed"); 
-#line 476 "lex.yy.c"
-
-/* Macros after this point can all be overridden by user definitions in
- * section 1.
- */
-
-#ifndef YY_SKIP_YYWRAP
-#ifdef __cplusplus
-extern "C" int yywrap YY_PROTO(( void ));
-#else
-extern int yywrap YY_PROTO(( void ));
-#endif
-#endif
-
-#ifndef YY_NO_UNPUT
-static void yyunput YY_PROTO(( int c, char *buf_ptr ));
-#endif
-
-#ifndef yytext_ptr
-static void yy_flex_strncpy YY_PROTO(( char *, yyconst char *, int ));
-#endif
-
-#ifdef YY_NEED_STRLEN
-static int yy_flex_strlen YY_PROTO(( yyconst char * ));
-#endif
-
-#ifndef YY_NO_INPUT
-#ifdef __cplusplus
-static int yyinput YY_PROTO(( void ));
-#else
-static int input YY_PROTO(( void ));
-#endif
-#endif
-
-#if YY_STACK_USED
-static int yy_start_stack_ptr = 0;
-static int yy_start_stack_depth = 0;
-static int *yy_start_stack = 0;
-#ifndef YY_NO_PUSH_STATE
-static void yy_push_state YY_PROTO(( int new_state ));
-#endif
-#ifndef YY_NO_POP_STATE
-static void yy_pop_state YY_PROTO(( void ));
-#endif
-#ifndef YY_NO_TOP_STATE
-static int yy_top_state YY_PROTO(( void ));
-#endif
-
-#else
-#define YY_NO_PUSH_STATE 1
-#define YY_NO_POP_STATE 1
-#define YY_NO_TOP_STATE 1
-#endif
-
-#ifdef YY_MALLOC_DECL
-YY_MALLOC_DECL
-#else
-#if __STDC__
-#ifndef __cplusplus
-#include <stdlib.h>
-#endif
-#else
-/* Just try to get by without declaring the routines.  This will fail
- * miserably on non-ANSI systems for which sizeof(size_t) != sizeof(int)
- * or sizeof(void*) != sizeof(int).
- */
-#endif
-#endif
-
-/* Amount of stuff to slurp up with each read. */
-#ifndef YY_READ_BUF_SIZE
-#define YY_READ_BUF_SIZE 8192
-#endif
-
-/* Copy whatever the last rule matched to the standard output. */
-
-#ifndef ECHO
-/* This used to be an fputs(), but since the string might contain NUL's,
- * we now use fwrite().
- */
-#define ECHO (void) fwrite( yytext, yyleng, 1, yyout )
-#endif
-
-/* Gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
- * is returned in "result".
- */
-#ifndef YY_INPUT
-#define YY_INPUT(buf,result,max_size) \
-	if ( yy_current_buffer->yy_is_interactive ) \
-		{ \
-		int c = '*', n; \
-		for ( n = 0; n < max_size && \
-			     (c = getc( yyin )) != EOF && c != '\n'; ++n ) \
-			buf[n] = (char) c; \
-		if ( c == '\n' ) \
-			buf[n++] = (char) c; \
-		if ( c == EOF && ferror( yyin ) ) \
-			YY_FATAL_ERROR( "input in flex scanner failed" ); \
-		result = n; \
-		} \
-	else \
-		{ \
-		errno=0; \
-		while ( (result = fread(buf, 1, max_size, yyin))==0 && ferror(yyin)) \
-			{ \
-			if( errno != EINTR) \
-				{ \
-				YY_FATAL_ERROR( "input in flex scanner failed" ); \
-				break; \
-				} \
-			errno=0; \
-			clearerr(yyin); \
-			} \
-		}
-#endif
-
-/* No semi-colon after return; correct usage is to write "yyterminate();" -
- * we don't want an extra ';' after the "return" because that will cause
- * some compilers to complain about unreachable statements.
- */
-#ifndef yyterminate
-#define yyterminate() return YY_NULL
-#endif
-
-/* Number of entries by which start-condition stack grows. */
-#ifndef YY_START_STACK_INCR
-#define YY_START_STACK_INCR 25
-#endif
-
-/* Report a fatal error. */
-#ifndef YY_FATAL_ERROR
-#define YY_FATAL_ERROR(msg) yy_fatal_error( msg )
-#endif
-
-/* Default declaration of generated scanner - a define so the user can
- * easily add parameters.
- */
-#ifndef YY_DECL
-#define YY_DECL int yylex YY_PROTO(( void ))
-#endif
-
-/* Code executed at the beginning of each rule, after yytext and yyleng
- * have been set up.
- */
-#ifndef YY_USER_ACTION
-#define YY_USER_ACTION
-#endif
-
-/* Code executed at the end of each rule. */
-#ifndef YY_BREAK
-#define YY_BREAK break;
-#endif
-
-#define YY_RULE_SETUP \
-	YY_USER_ACTION
-
-YY_DECL
-	{
-	register yy_state_type yy_current_state;
-	register char *yy_cp, *yy_bp;
-	register int yy_act;
-
-#line 83 "ircd_lexer.l"
-
-#line 640 "lex.yy.c"
-
-	if ( yy_init )
-		{
-		yy_init = 0;
-
-#ifdef YY_USER_INIT
-		YY_USER_INIT;
-#endif
-
-		if ( ! yy_start )
-			yy_start = 1;	/* first start state */
-
-		if ( ! yyin )
-			yyin = stdin;
-
-		if ( ! yyout )
-			yyout = stdout;
-
-		if ( ! yy_current_buffer )
-			yy_current_buffer =
-				yy_create_buffer( yyin, YY_BUF_SIZE );
-
-		yy_load_buffer_state();
-		}
-
-	while ( 1 )		/* loops until end-of-file is reached */
-		{
-		yy_more_len = 0;
-		if ( yy_more_flag )
-			{
-			yy_more_len = yy_c_buf_p - yytext_ptr;
-			yy_more_flag = 0;
-			}
-		yy_cp = yy_c_buf_p;
-
-		/* Support of yytext. */
-		*yy_cp = yy_hold_char;
-
-		/* yy_bp points to the position in yy_ch_buf of the start of
-		 * the current run.
-		 */
-		yy_bp = yy_cp;
-
-		yy_current_state = yy_start;
-yy_match:
-		do
-			{
-			register YY_CHAR yy_c = yy_ec[YY_SC_TO_UI(*yy_cp)];
-			if ( yy_accept[yy_current_state] )
-				{
-				yy_last_accepting_state = yy_current_state;
-				yy_last_accepting_cpos = yy_cp;
-				}
-			while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
-				{
-				yy_current_state = (int) yy_def[yy_current_state];
-				if ( yy_current_state >= 47 )
-					yy_c = yy_meta[(unsigned int) yy_c];
-				}
-			yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
-			++yy_cp;
-			}
-		while ( yy_base[yy_current_state] != 74 );
-
-yy_find_action:
-		yy_act = yy_accept[yy_current_state];
-		if ( yy_act == 0 )
-			{ /* have to back up */
-			yy_cp = yy_last_accepting_cpos;
-			yy_current_state = yy_last_accepting_state;
-			yy_act = yy_accept[yy_current_state];
-			}
-
-		YY_DO_BEFORE_ACTION;
-
-
-do_action:	/* This label is used only to access EOF actions. */
-
-
-		switch ( yy_act )
-	{ /* beginning of action switch */
-			case 0: /* must back up */
-			/* undo the effects of YY_DO_BEFORE_ACTION */
-			*yy_cp = yy_hold_char;
-			yy_cp = yy_last_accepting_cpos;
-			yy_current_state = yy_last_accepting_state;
-			goto yy_find_action;
-
-case 1:
-YY_RULE_SETUP
-#line 84 "ircd_lexer.l"
-{ cinclude(); }
-	YY_BREAK
-case 2:
-YY_RULE_SETUP
-#line 85 "ircd_lexer.l"
-{ ccomment(); }
-	YY_BREAK
-case 3:
-YY_RULE_SETUP
-#line 86 "ircd_lexer.l"
-{ strcpy(linebuf, yytext+1); lineno++; yyless(1); }
-	YY_BREAK
-case 4:
-YY_RULE_SETUP
-#line 88 "ircd_lexer.l"
-;
-	YY_BREAK
-case 5:
-YY_RULE_SETUP
-#line 89 "ircd_lexer.l"
-{ hashcomment(); }
-	YY_BREAK
-case 6:
-YY_RULE_SETUP
-#line 91 "ircd_lexer.l"
-{ yylval.number = atoi(yytext); return NUMBER; }
-	YY_BREAK
-case 7:
-YY_RULE_SETUP
-#line 93 "ircd_lexer.l"
-{
-                  if(yytext[yyleng-2] == '\\')
-                    {
-                      yyless(yyleng-1); /* return last quote */
-                      yymore();         /* append next string */
-                    }
-                  else
-                    {
-                      strcpy(yylval.string, yytext + 1);
-                      if(yylval.string[yyleng-2] != '"')
-                        ilog(L_ERROR, "Unterminated character string");
-                      else
-                        {
-                          int i,j;
-                          yylval.string[yyleng-2] = '\0'; /* remove close
-                                                           *  quote 
-                                                           */
-                          
-                          for (j=i=0 ;yylval.string[i] != '\0'; i++,j++)
-                            {
-                              if (yylval.string[i] != '\\')
-                                {
-                                  yylval.string[j] = yylval.string[i];
-                                }
-                              else
-                                {
-                                  i++;
-                                  if (yylval.string[i] == '\0') /* XXX 
-                                                                 * should not
-                                                                 * happen
-                                                                 */
-                                    {
-                                      ilog(L_ERROR,
-                                           "Unterminated character string");
-                                      break;
-                                    }
-                                  yylval.string[j] = yylval.string[i];
-                                }
-                            }
-                          yylval.string[j] = '\0';
-                          return QSTRING;
-                        }
-                    }
-                }
-	YY_BREAK
-case 8:
-YY_RULE_SETUP
-#line 139 "ircd_lexer.l"
-{ return LOADMODULE; }
-	YY_BREAK
-case 9:
-YY_RULE_SETUP
-#line 140 "ircd_lexer.l"
-{ 
-		  strcpy(yylval.string, yytext);
-                  yylval.string[yyleng] = '\0';
-                  return STRING;
-                }
-	YY_BREAK
-case 10:
-YY_RULE_SETUP
-#line 146 "ircd_lexer.l"
-{ return TWODOTS; }
-	YY_BREAK
-case 11:
-YY_RULE_SETUP
-#line 147 "ircd_lexer.l"
-{ return yytext[0]; }
-	YY_BREAK
-case YY_STATE_EOF(INITIAL):
-#line 148 "ircd_lexer.l"
-{ if (ieof()) yyterminate(); }
-	YY_BREAK
-case 12:
-YY_RULE_SETUP
-#line 149 "ircd_lexer.l"
-ECHO;
-	YY_BREAK
-#line 840 "lex.yy.c"
-
-	case YY_END_OF_BUFFER:
-		{
-		/* Amount of text matched not including the EOB char. */
-		int yy_amount_of_matched_text = (int) (yy_cp - yytext_ptr) - 1;
-
-		/* Undo the effects of YY_DO_BEFORE_ACTION. */
-		*yy_cp = yy_hold_char;
-		YY_RESTORE_YY_MORE_OFFSET
-
-		if ( yy_current_buffer->yy_buffer_status == YY_BUFFER_NEW )
-			{
-			/* We're scanning a new file or input source.  It's
-			 * possible that this happened because the user
-			 * just pointed yyin at a new source and called
-			 * yylex().  If so, then we have to assure
-			 * consistency between yy_current_buffer and our
-			 * globals.  Here is the right place to do so, because
-			 * this is the first action (other than possibly a
-			 * back-up) that will match for the new input source.
-			 */
-			yy_n_chars = yy_current_buffer->yy_n_chars;
-			yy_current_buffer->yy_input_file = yyin;
-			yy_current_buffer->yy_buffer_status = YY_BUFFER_NORMAL;
-			}
-
-		/* Note that here we test for yy_c_buf_p "<=" to the position
-		 * of the first EOB in the buffer, since yy_c_buf_p will
-		 * already have been incremented past the NUL character
-		 * (since all states make transitions on EOB to the
-		 * end-of-buffer state).  Contrast this with the test
-		 * in input().
-		 */
-		if ( yy_c_buf_p <= &yy_current_buffer->yy_ch_buf[yy_n_chars] )
-			{ /* This was really a NUL. */
-			yy_state_type yy_next_state;
-
-			yy_c_buf_p = yytext_ptr + yy_amount_of_matched_text;
-
-			yy_current_state = yy_get_previous_state();
-
-			/* Okay, we're now positioned to make the NUL
-			 * transition.  We couldn't have
-			 * yy_get_previous_state() go ahead and do it
-			 * for us because it doesn't know how to deal
-			 * with the possibility of jamming (and we don't
-			 * want to build jamming into it because then it
-			 * will run more slowly).
-			 */
-
-			yy_next_state = yy_try_NUL_trans( yy_current_state );
-
-			yy_bp = yytext_ptr + YY_MORE_ADJ;
-
-			if ( yy_next_state )
-				{
-				/* Consume the NUL. */
-				yy_cp = ++yy_c_buf_p;
-				yy_current_state = yy_next_state;
-				goto yy_match;
-				}
-
-			else
-				{
-				yy_cp = yy_c_buf_p;
-				goto yy_find_action;
-				}
-			}
-
-		else switch ( yy_get_next_buffer() )
-			{
-			case EOB_ACT_END_OF_FILE:
-				{
-				yy_did_buffer_switch_on_eof = 0;
-
-				if ( yywrap() )
-					{
-					/* Note: because we've taken care in
-					 * yy_get_next_buffer() to have set up
-					 * yytext, we can now set up
-					 * yy_c_buf_p so that if some total
-					 * hoser (like flex itself) wants to
-					 * call the scanner after we return the
-					 * YY_NULL, it'll still work - another
-					 * YY_NULL will get returned.
-					 */
-					yy_c_buf_p = yytext_ptr + YY_MORE_ADJ;
-
-					yy_act = YY_STATE_EOF(YY_START);
-					goto do_action;
-					}
-
-				else
-					{
-					if ( ! yy_did_buffer_switch_on_eof )
-						YY_NEW_FILE;
-					}
-				break;
-				}
-
-			case EOB_ACT_CONTINUE_SCAN:
-				yy_c_buf_p =
-					yytext_ptr + yy_amount_of_matched_text;
-
-				yy_current_state = yy_get_previous_state();
-
-				yy_cp = yy_c_buf_p;
-				yy_bp = yytext_ptr + YY_MORE_ADJ;
-				goto yy_match;
-
-			case EOB_ACT_LAST_MATCH:
-				yy_c_buf_p =
-				&yy_current_buffer->yy_ch_buf[yy_n_chars];
-
-				yy_current_state = yy_get_previous_state();
-
-				yy_cp = yy_c_buf_p;
-				yy_bp = yytext_ptr + YY_MORE_ADJ;
-				goto yy_find_action;
-			}
-		break;
-		}
-
-	default:
-		YY_FATAL_ERROR(
-			"fatal flex scanner internal error--no action found" );
-	} /* end of action switch */
-		} /* end of scanning one token */
-	} /* end of yylex */
-
-
-/* yy_get_next_buffer - try to read in a new buffer
- *
- * Returns a code representing an action:
- *	EOB_ACT_LAST_MATCH -
- *	EOB_ACT_CONTINUE_SCAN - continue scanning from current position
- *	EOB_ACT_END_OF_FILE - end of file
- */
-
-static int yy_get_next_buffer()
-	{
-	register char *dest = yy_current_buffer->yy_ch_buf;
-	register char *source = yytext_ptr;
-	register int number_to_move, i;
-	int ret_val;
-
-	if ( yy_c_buf_p > &yy_current_buffer->yy_ch_buf[yy_n_chars + 1] )
-		YY_FATAL_ERROR(
-		"fatal flex scanner internal error--end of buffer missed" );
-
-	if ( yy_current_buffer->yy_fill_buffer == 0 )
-		{ /* Don't try to fill the buffer, so this is an EOF. */
-		if ( yy_c_buf_p - yytext_ptr - YY_MORE_ADJ == 1 )
-			{
-			/* We matched a single character, the EOB, so
-			 * treat this as a final EOF.
-			 */
-			return EOB_ACT_END_OF_FILE;
-			}
-
-		else
-			{
-			/* We matched some text prior to the EOB, first
-			 * process it.
-			 */
-			return EOB_ACT_LAST_MATCH;
-			}
-		}
-
-	/* Try to read more data. */
-
-	/* First move last chars to start of buffer. */
-	number_to_move = (int) (yy_c_buf_p - yytext_ptr) - 1;
-
-	for ( i = 0; i < number_to_move; ++i )
-		*(dest++) = *(source++);
-
-	if ( yy_current_buffer->yy_buffer_status == YY_BUFFER_EOF_PENDING )
-		/* don't do the read, it's not guaranteed to return an EOF,
-		 * just force an EOF
-		 */
-		yy_current_buffer->yy_n_chars = yy_n_chars = 0;
-
-	else
-		{
-		int num_to_read =
-			yy_current_buffer->yy_buf_size - number_to_move - 1;
-
-		while ( num_to_read <= 0 )
-			{ /* Not enough room in the buffer - grow it. */
-#ifdef YY_USES_REJECT
-			YY_FATAL_ERROR(
-"input buffer overflow, can't enlarge buffer because scanner uses REJECT" );
-#else
-
-			/* just a shorter name for the current buffer */
-			YY_BUFFER_STATE b = yy_current_buffer;
-
-			int yy_c_buf_p_offset =
-				(int) (yy_c_buf_p - b->yy_ch_buf);
-
-			if ( b->yy_is_our_buffer )
-				{
-				int new_size = b->yy_buf_size * 2;
-
-				if ( new_size <= 0 )
-					b->yy_buf_size += b->yy_buf_size / 8;
-				else
-					b->yy_buf_size *= 2;
-
-				b->yy_ch_buf = (char *)
-					/* Include room in for 2 EOB chars. */
-					yy_flex_realloc( (void *) b->yy_ch_buf,
-							 b->yy_buf_size + 2 );
-				}
-			else
-				/* Can't grow it, we don't own it. */
-				b->yy_ch_buf = 0;
-
-			if ( ! b->yy_ch_buf )
-				YY_FATAL_ERROR(
-				"fatal error - scanner input buffer overflow" );
-
-			yy_c_buf_p = &b->yy_ch_buf[yy_c_buf_p_offset];
-
-			num_to_read = yy_current_buffer->yy_buf_size -
-						number_to_move - 1;
-#endif
-			}
-
-		if ( num_to_read > YY_READ_BUF_SIZE )
-			num_to_read = YY_READ_BUF_SIZE;
-
-		/* Read in more data. */
-		YY_INPUT( (&yy_current_buffer->yy_ch_buf[number_to_move]),
-			yy_n_chars, num_to_read );
-
-		yy_current_buffer->yy_n_chars = yy_n_chars;
-		}
-
-	if ( yy_n_chars == 0 )
-		{
-		if ( number_to_move == YY_MORE_ADJ )
-			{
-			ret_val = EOB_ACT_END_OF_FILE;
-			yyrestart( yyin );
-			}
-
-		else
-			{
-			ret_val = EOB_ACT_LAST_MATCH;
-			yy_current_buffer->yy_buffer_status =
-				YY_BUFFER_EOF_PENDING;
-			}
-		}
-
-	else
-		ret_val = EOB_ACT_CONTINUE_SCAN;
-
-	yy_n_chars += number_to_move;
-	yy_current_buffer->yy_ch_buf[yy_n_chars] = YY_END_OF_BUFFER_CHAR;
-	yy_current_buffer->yy_ch_buf[yy_n_chars + 1] = YY_END_OF_BUFFER_CHAR;
-
-	yytext_ptr = &yy_current_buffer->yy_ch_buf[0];
-
-	return ret_val;
-	}
-
-
-/* yy_get_previous_state - get the state just before the EOB char was reached */
-
-static yy_state_type yy_get_previous_state()
-	{
-	register yy_state_type yy_current_state;
-	register char *yy_cp;
-
-	yy_current_state = yy_start;
-
-	for ( yy_cp = yytext_ptr + YY_MORE_ADJ; yy_cp < yy_c_buf_p; ++yy_cp )
-		{
-		register YY_CHAR yy_c = (*yy_cp ? yy_ec[YY_SC_TO_UI(*yy_cp)] : 1);
-		if ( yy_accept[yy_current_state] )
-			{
-			yy_last_accepting_state = yy_current_state;
-			yy_last_accepting_cpos = yy_cp;
-			}
-		while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
-			{
-			yy_current_state = (int) yy_def[yy_current_state];
-			if ( yy_current_state >= 47 )
-				yy_c = yy_meta[(unsigned int) yy_c];
-			}
-		yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
-		}
-
-	return yy_current_state;
-	}
-
-
-/* yy_try_NUL_trans - try to make a transition on the NUL character
- *
- * synopsis
- *	next_state = yy_try_NUL_trans( current_state );
- */
-
-#ifdef YY_USE_PROTOS
-static yy_state_type yy_try_NUL_trans( yy_state_type yy_current_state )
-#else
-static yy_state_type yy_try_NUL_trans( yy_current_state )
-yy_state_type yy_current_state;
-#endif
-	{
-	register int yy_is_jam;
-	register char *yy_cp = yy_c_buf_p;
-
-	register YY_CHAR yy_c = 1;
-	if ( yy_accept[yy_current_state] )
-		{
-		yy_last_accepting_state = yy_current_state;
-		yy_last_accepting_cpos = yy_cp;
-		}
-	while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
-		{
-		yy_current_state = (int) yy_def[yy_current_state];
-		if ( yy_current_state >= 47 )
-			yy_c = yy_meta[(unsigned int) yy_c];
-		}
-	yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
-	yy_is_jam = (yy_current_state == 46);
-
-	return yy_is_jam ? 0 : yy_current_state;
-	}
-
-
-#ifndef YY_NO_UNPUT
-#ifdef YY_USE_PROTOS
-static void yyunput( int c, register char *yy_bp )
-#else
-static void yyunput( c, yy_bp )
-int c;
-register char *yy_bp;
-#endif
-	{
-	register char *yy_cp = yy_c_buf_p;
-
-	/* undo effects of setting up yytext */
-	*yy_cp = yy_hold_char;
-
-	if ( yy_cp < yy_current_buffer->yy_ch_buf + 2 )
-		{ /* need to shift things up to make room */
-		/* +2 for EOB chars. */
-		register int number_to_move = yy_n_chars + 2;
-		register char *dest = &yy_current_buffer->yy_ch_buf[
-					yy_current_buffer->yy_buf_size + 2];
-		register char *source =
-				&yy_current_buffer->yy_ch_buf[number_to_move];
-
-		while ( source > yy_current_buffer->yy_ch_buf )
-			*--dest = *--source;
-
-		yy_cp += (int) (dest - source);
-		yy_bp += (int) (dest - source);
-		yy_current_buffer->yy_n_chars =
-			yy_n_chars = yy_current_buffer->yy_buf_size;
-
-		if ( yy_cp < yy_current_buffer->yy_ch_buf + 2 )
-			YY_FATAL_ERROR( "flex scanner push-back overflow" );
-		}
-
-	*--yy_cp = (char) c;
-
-
-	yytext_ptr = yy_bp;
-	yy_hold_char = *yy_cp;
-	yy_c_buf_p = yy_cp;
-	}
-#endif	/* ifndef YY_NO_UNPUT */
-
-
-#ifdef __cplusplus
-static int yyinput()
-#else
-static int input()
-#endif
-	{
-	int c;
-
-	*yy_c_buf_p = yy_hold_char;
-
-	if ( *yy_c_buf_p == YY_END_OF_BUFFER_CHAR )
-		{
-		/* yy_c_buf_p now points to the character we want to return.
-		 * If this occurs *before* the EOB characters, then it's a
-		 * valid NUL; if not, then we've hit the end of the buffer.
-		 */
-		if ( yy_c_buf_p < &yy_current_buffer->yy_ch_buf[yy_n_chars] )
-			/* This was really a NUL. */
-			*yy_c_buf_p = '\0';
-
-		else
-			{ /* need more input */
-			int offset = yy_c_buf_p - yytext_ptr;
-			++yy_c_buf_p;
-
-			switch ( yy_get_next_buffer() )
-				{
-				case EOB_ACT_LAST_MATCH:
-					/* This happens because yy_g_n_b()
-					 * sees that we've accumulated a
-					 * token and flags that we need to
-					 * try matching the token before
-					 * proceeding.  But for input(),
-					 * there's no matching to consider.
-					 * So convert the EOB_ACT_LAST_MATCH
-					 * to EOB_ACT_END_OF_FILE.
-					 */
-
-					/* Reset buffer status. */
-					yyrestart( yyin );
-
-					/* fall through */
-
-				case EOB_ACT_END_OF_FILE:
-					{
-					if ( yywrap() )
-						return EOF;
-
-					if ( ! yy_did_buffer_switch_on_eof )
-						YY_NEW_FILE;
-#ifdef __cplusplus
-					return yyinput();
-#else
-					return input();
-#endif
-					}
-
-				case EOB_ACT_CONTINUE_SCAN:
-					yy_c_buf_p = yytext_ptr + offset;
-					break;
-				}
-			}
-		}
-
-	c = *(unsigned char *) yy_c_buf_p;	/* cast for 8-bit char's */
-	*yy_c_buf_p = '\0';	/* preserve yytext */
-	yy_hold_char = *++yy_c_buf_p;
-
-
-	return c;
-	}
-
-
-#ifdef YY_USE_PROTOS
-void yyrestart( FILE *input_file )
-#else
-void yyrestart( input_file )
-FILE *input_file;
-#endif
-	{
-	if ( ! yy_current_buffer )
-		yy_current_buffer = yy_create_buffer( yyin, YY_BUF_SIZE );
-
-	yy_init_buffer( yy_current_buffer, input_file );
-	yy_load_buffer_state();
-	}
-
-
-#ifdef YY_USE_PROTOS
-void yy_switch_to_buffer( YY_BUFFER_STATE new_buffer )
-#else
-void yy_switch_to_buffer( new_buffer )
-YY_BUFFER_STATE new_buffer;
-#endif
-	{
-	if ( yy_current_buffer == new_buffer )
-		return;
-
-	if ( yy_current_buffer )
-		{
-		/* Flush out information for old buffer. */
-		*yy_c_buf_p = yy_hold_char;
-		yy_current_buffer->yy_buf_pos = yy_c_buf_p;
-		yy_current_buffer->yy_n_chars = yy_n_chars;
-		}
-
-	yy_current_buffer = new_buffer;
-	yy_load_buffer_state();
-
-	/* We don't actually know whether we did this switch during
-	 * EOF (yywrap()) processing, but the only time this flag
-	 * is looked at is after yywrap() is called, so it's safe
-	 * to go ahead and always set it.
-	 */
-	yy_did_buffer_switch_on_eof = 1;
-	}
-
-
-#ifdef YY_USE_PROTOS
-void yy_load_buffer_state( void )
-#else
-void yy_load_buffer_state()
-#endif
-	{
-	yy_n_chars = yy_current_buffer->yy_n_chars;
-	yytext_ptr = yy_c_buf_p = yy_current_buffer->yy_buf_pos;
-	yyin = yy_current_buffer->yy_input_file;
-	yy_hold_char = *yy_c_buf_p;
-	}
-
-
-#ifdef YY_USE_PROTOS
-YY_BUFFER_STATE yy_create_buffer( FILE *file, int size )
-#else
-YY_BUFFER_STATE yy_create_buffer( file, size )
-FILE *file;
-int size;
-#endif
-	{
-	YY_BUFFER_STATE b;
-
-	b = (YY_BUFFER_STATE) yy_flex_alloc( sizeof( struct yy_buffer_state ) );
-	if ( ! b )
-		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );
-
-	b->yy_buf_size = size;
-
-	/* yy_ch_buf has to be 2 characters longer than the size given because
-	 * we need to put in 2 end-of-buffer characters.
-	 */
-	b->yy_ch_buf = (char *) yy_flex_alloc( b->yy_buf_size + 2 );
-	if ( ! b->yy_ch_buf )
-		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );
-
-	b->yy_is_our_buffer = 1;
-
-	yy_init_buffer( b, file );
-
-	return b;
-	}
-
-
-#ifdef YY_USE_PROTOS
-void yy_delete_buffer( YY_BUFFER_STATE b )
-#else
-void yy_delete_buffer( b )
-YY_BUFFER_STATE b;
-#endif
-	{
-	if ( ! b )
-		return;
-
-	if ( b == yy_current_buffer )
-		yy_current_buffer = (YY_BUFFER_STATE) 0;
-
-	if ( b->yy_is_our_buffer )
-		yy_flex_free( (void *) b->yy_ch_buf );
-
-	yy_flex_free( (void *) b );
-	}
-
-
-#ifndef _WIN32
-#include <unistd.h>
-#else
-#ifndef YY_ALWAYS_INTERACTIVE
-#ifndef YY_NEVER_INTERACTIVE
-extern int isatty YY_PROTO(( int ));
-#endif
-#endif
-#endif
-
-#ifdef YY_USE_PROTOS
-void yy_init_buffer( YY_BUFFER_STATE b, FILE *file )
-#else
-void yy_init_buffer( b, file )
-YY_BUFFER_STATE b;
-FILE *file;
-#endif
-
-
-	{
-	yy_flush_buffer( b );
-
-	b->yy_input_file = file;
-	b->yy_fill_buffer = 1;
-
-#if YY_ALWAYS_INTERACTIVE
-	b->yy_is_interactive = 1;
-#else
-#if YY_NEVER_INTERACTIVE
-	b->yy_is_interactive = 0;
-#else
-	b->yy_is_interactive = file ? (isatty( fileno(file) ) > 0) : 0;
-#endif
-#endif
-	}
-
-
-#ifdef YY_USE_PROTOS
-void yy_flush_buffer( YY_BUFFER_STATE b )
-#else
-void yy_flush_buffer( b )
-YY_BUFFER_STATE b;
-#endif
-
-	{
-	if ( ! b )
-		return;
-
-	b->yy_n_chars = 0;
-
-	/* We always need two end-of-buffer characters.  The first causes
-	 * a transition to the end-of-buffer state.  The second causes
-	 * a jam in that state.
-	 */
-	b->yy_ch_buf[0] = YY_END_OF_BUFFER_CHAR;
-	b->yy_ch_buf[1] = YY_END_OF_BUFFER_CHAR;
-
-	b->yy_buf_pos = &b->yy_ch_buf[0];
-
-	b->yy_at_bol = 1;
-	b->yy_buffer_status = YY_BUFFER_NEW;
-
-	if ( b == yy_current_buffer )
-		yy_load_buffer_state();
-	}
-
-
-#ifndef YY_NO_SCAN_BUFFER
-#ifdef YY_USE_PROTOS
-YY_BUFFER_STATE yy_scan_buffer( char *base, yy_size_t size )
-#else
-YY_BUFFER_STATE yy_scan_buffer( base, size )
-char *base;
-yy_size_t size;
-#endif
-	{
-	YY_BUFFER_STATE b;
-
-	if ( size < 2 ||
-	     base[size-2] != YY_END_OF_BUFFER_CHAR ||
-	     base[size-1] != YY_END_OF_BUFFER_CHAR )
-		/* They forgot to leave room for the EOB's. */
-		return 0;
-
-	b = (YY_BUFFER_STATE) yy_flex_alloc( sizeof( struct yy_buffer_state ) );
-	if ( ! b )
-		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_buffer()" );
-
-	b->yy_buf_size = size - 2;	/* "- 2" to take care of EOB's */
-	b->yy_buf_pos = b->yy_ch_buf = base;
-	b->yy_is_our_buffer = 0;
-	b->yy_input_file = 0;
-	b->yy_n_chars = b->yy_buf_size;
-	b->yy_is_interactive = 0;
-	b->yy_at_bol = 1;
-	b->yy_fill_buffer = 0;
-	b->yy_buffer_status = YY_BUFFER_NEW;
-
-	yy_switch_to_buffer( b );
-
-	return b;
-	}
-#endif
-
-
-#ifndef YY_NO_SCAN_STRING
-#ifdef YY_USE_PROTOS
-YY_BUFFER_STATE yy_scan_string( yyconst char *yy_str )
-#else
-YY_BUFFER_STATE yy_scan_string( yy_str )
-yyconst char *yy_str;
-#endif
-	{
-	int len;
-	for ( len = 0; yy_str[len]; ++len )
-		;
-
-	return yy_scan_bytes( yy_str, len );
-	}
-#endif
-
-
-#ifndef YY_NO_SCAN_BYTES
-#ifdef YY_USE_PROTOS
-YY_BUFFER_STATE yy_scan_bytes( yyconst char *bytes, int len )
-#else
-YY_BUFFER_STATE yy_scan_bytes( bytes, len )
-yyconst char *bytes;
-int len;
-#endif
-	{
-	YY_BUFFER_STATE b;
-	char *buf;
-	yy_size_t n;
-	int i;
-
-	/* Get memory for full buffer, including space for trailing EOB's. */
-	n = len + 2;
-	buf = (char *) yy_flex_alloc( n );
-	if ( ! buf )
-		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_bytes()" );
-
-	for ( i = 0; i < len; ++i )
-		buf[i] = bytes[i];
-
-	buf[len] = buf[len+1] = YY_END_OF_BUFFER_CHAR;
-
-	b = yy_scan_buffer( buf, n );
-	if ( ! b )
-		YY_FATAL_ERROR( "bad buffer in yy_scan_bytes()" );
-
-	/* It's okay to grow etc. this buffer, and we should throw it
-	 * away when we're done.
-	 */
-	b->yy_is_our_buffer = 1;
-
-	return b;
-	}
-#endif
-
-
-#ifndef YY_NO_PUSH_STATE
-#ifdef YY_USE_PROTOS
-static void yy_push_state( int new_state )
-#else
-static void yy_push_state( new_state )
-int new_state;
-#endif
-	{
-	if ( yy_start_stack_ptr >= yy_start_stack_depth )
-		{
-		yy_size_t new_size;
-
-		yy_start_stack_depth += YY_START_STACK_INCR;
-		new_size = yy_start_stack_depth * sizeof( int );
-
-		if ( ! yy_start_stack )
-			yy_start_stack = (int *) yy_flex_alloc( new_size );
-
-		else
-			yy_start_stack = (int *) yy_flex_realloc(
-					(void *) yy_start_stack, new_size );
-
-		if ( ! yy_start_stack )
-			YY_FATAL_ERROR(
-			"out of memory expanding start-condition stack" );
-		}
-
-	yy_start_stack[yy_start_stack_ptr++] = YY_START;
-
-	BEGIN(new_state);
-	}
-#endif
-
-
-#ifndef YY_NO_POP_STATE
-static void yy_pop_state()
-	{
-	if ( --yy_start_stack_ptr < 0 )
-		YY_FATAL_ERROR( "start-condition stack underflow" );
-
-	BEGIN(yy_start_stack[yy_start_stack_ptr]);
-	}
-#endif
-
-
-#ifndef YY_NO_TOP_STATE
-static int yy_top_state()
-	{
-	return yy_start_stack[yy_start_stack_ptr - 1];
-	}
-#endif
-
-#ifndef YY_EXIT_FAILURE
-#define YY_EXIT_FAILURE 2
-#endif
-
-#ifdef YY_USE_PROTOS
-static void yy_fatal_error( yyconst char msg[] )
-#else
-static void yy_fatal_error( msg )
-char msg[];
-#endif
-	{
-	(void) fprintf( stderr, "%s\n", msg );
-	exit( YY_EXIT_FAILURE );
-	}
-
-
-
-/* Redefine yyless() so it works in section 3 code. */
-
-#undef yyless
-#define yyless(n) \
-	do \
-		{ \
-		/* Undo effects of setting up yytext. */ \
-		yytext[yyleng] = yy_hold_char; \
-		yy_c_buf_p = yytext + n; \
-		yy_hold_char = *yy_c_buf_p; \
-		*yy_c_buf_p = '\0'; \
-		yyleng = n; \
-		} \
-	while ( 0 )
-
-
-/* Internal utility routines. */
-
-#ifndef yytext_ptr
-#ifdef YY_USE_PROTOS
-static void yy_flex_strncpy( char *s1, yyconst char *s2, int n )
-#else
-static void yy_flex_strncpy( s1, s2, n )
-char *s1;
-yyconst char *s2;
-int n;
-#endif
-	{
-	register int i;
-	for ( i = 0; i < n; ++i )
-		s1[i] = s2[i];
-	}
-#endif
-
-#ifdef YY_NEED_STRLEN
-#ifdef YY_USE_PROTOS
-static int yy_flex_strlen( yyconst char *s )
-#else
-static int yy_flex_strlen( s )
-yyconst char *s;
-#endif
-	{
-	register int n;
-	for ( n = 0; s[n]; ++n )
-		;
-
-	return n;
-	}
-#endif
-
-
-#ifdef YY_USE_PROTOS
-static void *yy_flex_alloc( yy_size_t size )
-#else
-static void *yy_flex_alloc( size )
-yy_size_t size;
-#endif
-	{
-	return (void *) malloc( size );
-	}
-
-#ifdef YY_USE_PROTOS
-static void *yy_flex_realloc( void *ptr, yy_size_t size )
-#else
-static void *yy_flex_realloc( ptr, size )
-void *ptr;
-yy_size_t size;
-#endif
-	{
-	/* The cast to (char *) in the following accommodates both
-	 * implementations that use char* generic pointers, and those
-	 * that use void* generic pointers.  It works with the latter
-	 * because both ANSI C and C++ allow castless assignment from
-	 * any pointer type to void*, and deal with argument conversions
-	 * as though doing an assignment.
-	 */
-	return (void *) realloc( (char *) ptr, size );
-	}
-
-#ifdef YY_USE_PROTOS
-static void yy_flex_free( void *ptr )
-#else
-static void yy_flex_free( ptr )
-void *ptr;
-#endif
-	{
-	free( ptr );
-	}
-
-#if YY_MAIN
-int main()
-	{
-	yylex();
-	return 0;
-	}
-#endif
-#line 149 "ircd_lexer.l"
-
-
-/* C-comment ignoring routine -kre*/
-void ccomment()
-{
-  int c;
-  
-  /* log(L_NOTICE, "got comment"); */
-  while (1)
-    {
-      while ((c = input()) != '*' && c != EOF)
-        if (c == '\n') ++lineno;
-      if (c == '*')
-        {
-          while ((c = input()) == '*');
-          if (c == '/') 
-            break;
-        }
-      if (c == EOF)
-        {
-          YY_FATAL_ERROR("EOF in comment");
-          /* XXX hack alert this disables
-           * the stupid unused function warning
-           * gcc generates
-           */
-          yy_fatal_error("EOF in comment");
-          break;
-        }
-    }
-}
-
-void cinclude(void)
-{
-  char *c;
-  if ((c = strchr(yytext, '<')) == NULL)
-    *strchr(c = strchr(yytext, '"') + 1, '"') = 0;
-  else
-    *strchr(++c, '>') = 0;
-
-  /* do stacking and co. */ 
-  if (include_stack_ptr >= MAX_INCLUDE_DEPTH)
-    conf_report_error("Includes nested too deep (max is %d)", MAX_INCLUDE_DEPTH);
-  else
-  {
-    FBFILE *tmp_fbfile_in;
-    
-    tmp_fbfile_in = fbopen(c, "r");
-    
-    if (tmp_fbfile_in == NULL)
-    {
-      conf_report_error("Include %s: %s.", c, strerror(errno));
-      return;
-    }
-    lineno_stack[include_stack_ptr] = lineno;
-    lineno = 1;
-    inc_fbfile_in[include_stack_ptr] = conf_fbfile_in;
-    include_stack[include_stack_ptr++] = YY_CURRENT_BUFFER;
-    conf_fbfile_in = tmp_fbfile_in;
-    yy_switch_to_buffer(yy_create_buffer(yyin, YY_BUF_SIZE));
-  }
-}
-
-int ieof(void)
-{
-  if (include_stack_ptr)
-    fbclose(conf_fbfile_in);
-  if (--include_stack_ptr < 0)
-  {
-    /* We will now exit the lexer - restore init values if we get /rehash
-     * later and reenter lexer -kre */
-    include_stack_ptr = 0;
-    lineno = 1;
-    return 1;
-  }
-  /* switch buffer */
-  yy_delete_buffer(YY_CURRENT_BUFFER);
-  lineno = lineno_stack[include_stack_ptr];
-  conf_fbfile_in = inc_fbfile_in[include_stack_ptr];
-  strlcpy(conffilebuf, conffile_stack[include_stack_ptr], IRCD_BUFSIZE); 
-  yy_switch_to_buffer(include_stack[include_stack_ptr]);
-  return 0;
-}
-
-/* #-comment style, look for #include */
-#define INCLUDE "#include"
-
-void hashcomment(void)
-{
-  if (strlen(yytext) < sizeof(INCLUDE) - 1)
-    return;
-
-  if (!strncasecmp(yytext, INCLUDE, sizeof(INCLUDE) - 1))
-      yyerror("You probably meant '.include', skipping");
-}
diff -uNrd ircd-ratbox-1.1rc4/src/messages.tab ircd-7+BgFree-p6/src/messages.tab
--- ircd-ratbox-1.1rc4/src/messages.tab	Fri Feb  7 13:27:04 2003
+++ ircd-7+BgFree-p6/src/messages.tab	Sat Apr  5 18:34:48 2003
@@ -291,8 +291,8 @@
 /* 264 */       NULL,
 /* 265 RPL_LOCALUSERS, */       ":%s 265 %s :Current local  users: %d  Max: %d",
 /* 266 RPL_GLOBALUSERS, */      ":%s 266 %s :Current global users: %d  Max: %d",
-/* 267 */       NULL,
-/* 268 */       NULL,
+/* 267 RPL_IDENTUSERS, */       ":%s 267 %s :Current identified users: %d  Max: %d",
+/* 268 RPL_OSIDUSERS, */        ":%s 268 %s :Current services admins: %d  Max: %d",
 /* 269 */       NULL,
 /* 270 */       NULL,
 /* 271 */       NULL,
@@ -332,7 +332,7 @@
 /* 305 RPL_UNAWAY, */   ":%s 305 %s :You are no longer marked as being away",
 /* 306 RPL_NOWAWAY, */  ":%s 306 %s :You have been marked as being away",
 /* 307 */       NULL,
-/* 308 */       NULL,
+/* 308 RPL_WHOISADMIN,  */      ":%s 308 %s %s :is a Server Administrator",
 /* 309 */       NULL,
 /* 310 */       NULL,
 /* 311 RPL_WHOISUSER, */        ":%s 311 %s %s %s %s * :%s",
@@ -350,8 +350,8 @@
 /* 323 RPL_LISTEND, */          ":%s 323 %s :End of /LIST",
 /* 324 RPL_CHANNELMODEIS, */    ":%s 324 %s %s %s %s",
 /* 325 */       NULL,
-/* 326 */       NULL,
-/* 327 */       NULL,
+/* 326 RPL_WHOISSVSHINT, */     ":%s 326 %s %s :has identified for: this nick",
+/* 327 RPL_OS_ID, */            ":%s 327 %s %s :is a Network Administrator",
 /* 328 */       NULL,
 /* 329 RPL_CREATIONTIME, */      ":%s 329 %s %s %lu", 
 /* 330 */       NULL,
@@ -439,7 +439,7 @@
 /* 412 ERR_NOTEXTTOSEND, */     ":%s 412 %s :No text to send",
 /* 413 ERR_NOTOPLEVEL, */       ":%s 413 %s %s :No toplevel domain specified",
 /* 414 ERR_WILDTOPLEVEL, */     ":%s 414 %s %s :Wildcard in toplevel Domain",
-/* 415 */       NULL,
+/* 415 ERR_SERV_NICK, */        ":%s 415 %s %s :- You can not kick/deop services",
 /* 416 ERR_TOOMANYMATCHES */    ":%s 416 %s %s :output too large, truncated",
 /* 417 */       NULL,
 /* 418 */       NULL,
diff -uNrd ircd-ratbox-1.1rc4/src/modules.c ircd-7+BgFree-p6/src/modules.c
--- ircd-ratbox-1.1rc4/src/modules.c	Wed Feb  5 20:47:39 2003
+++ ircd-7+BgFree-p6/src/modules.c	Sat Apr  5 18:09:32 2003
@@ -593,6 +593,7 @@
 	mod_add_cmd(&squit_msgtab);
 	mod_add_cmd(&stats_msgtab);
 	mod_add_cmd(&svinfo_msgtab);
+        mod_add_cmd(&svshint_msgtab);
 	mod_add_cmd(&testline_msgtab);
 	mod_add_cmd(&time_msgtab);
 	mod_add_cmd(&topic_msgtab);
diff -uNrd ircd-ratbox-1.1rc4/src/s_misc.c ircd-7+BgFree-p6/src/s_misc.c
--- ircd-ratbox-1.1rc4/src/s_misc.c	Wed Feb  5 20:47:39 2003
+++ ircd-7+BgFree-p6/src/s_misc.c	Sun Apr  6 00:34:17 2003
@@ -53,6 +53,36 @@
 	"Thursday", "Friday", "Saturday"
 };
 
+/* next few lines are the services' nicks.Modify as needed -zer0c00l */
+
+char* servnicks[] = {
+         "CS" ,
+         "OS" ,
+         "STATSERV" ,
+         "SEEN" ,
+         "SEENSERV" ,
+         "ADMINSERV" ,
+         "SPLITSERV"
+};
+#define ARR_SIZE 7 /* number of services' nicks.Increase or decrease as needed */
+
+/* s_check ()
+ * will verify that the nick to be kicked is not a service nick
+ * and stop if it is
+ *                              -zer0c00l
+ */
+
+long s_check( char * szName )
+{
+    int i = 0;
+    for( i=0;i<ARR_SIZE;i++)
+        if( !strcasecmp(szName, servnicks[i]))
+            return 1;
+    return 0;
+}
+
+/* end of s_check() */
+
 char *
 date(time_t lclock)
 {
@@ -125,3 +155,62 @@
 	strftime(timebuffer, MAX_DATE_STRING, "%Y%m%d", tmptr);
 	return timebuffer;
 }
+
+/* no color -zer0c00l */
+char *strip_color(const char *p, int b)
+{
+  static char buf[512];
+  char *r, *q = buf;
+  int m, n;
+
+  do switch (*p) {
+
+  case '\003':
+    p++; if (isdigit(*p)) {
+      p++; m = *p>='0' && *p<='6';
+      n = *(p-1)=='1' || *(p-1)=='0';
+      if (m && n) {
+        p++; if (*p == ',') {
+          p++; if (isdigit(*p)) {
+            p++; m = *p>='0' && *p<='6';
+            n = *(p-1)=='1' || *(p-1)=='0';
+            if (m && n) {
+              p++;
+            }
+          }
+        }
+      } else if (*p == ',') {
+        p++; if (isdigit(*p)) {
+          p++; m = *p>='0' && *p<='6';
+          n = *(p-1)=='1' || *(p-1)=='0';
+          if (m && n) {
+            p++;
+          }
+        }
+      }
+    }
+    break;
+
+  case '\033':
+    p++; if (*p == '[') {
+      p++; r = strchr(p, 'm');
+      if (r) p = r + 1;
+    }
+    break;
+
+  case '\002':
+  case '\037':
+    if (b) {
+      p++; break;
+    }
+
+  default:
+    *q++ = *p++;
+    break;
+
+  } while (*p);
+
+  *q = 0;
+  return buf;
+}
+
diff -uNrd ircd-ratbox-1.1rc4/src/s_serv.c ircd-7+BgFree-p6/src/s_serv.c
--- ircd-ratbox-1.1rc4/src/s_serv.c	Thu Feb 13 15:53:17 2003
+++ ircd-7+BgFree-p6/src/s_serv.c	Sat Apr  5 18:27:12 2003
@@ -73,6 +73,11 @@
 int MaxClientCount = 1;
 int refresh_user_links = 0;
 
+int CurrentIdentUsers  = 0;
+int MaxIdentUsers  = 0;
+int CurrentOSidUsers = 0;
+int MaxOSidUsers = 0;
+
 static void start_io(struct Client *server);
 static void burst_members(struct Client *client_p, dlink_list * list);
 
@@ -813,6 +818,13 @@
 			   ubuf,
 			   target_p->username, target_p->host,
 			   target_p->user->server, target_p->info);
+
+	 if (IsNSId(target_p))
+          sendto_one(client_p, "SVSHINT NSID %s 1", target_p->name);
+
+        if (IsOSId(target_p))
+        sendto_one(client_p, "SVSHINT OSID %s 1", target_p->name);
+
 }
 
 /*
diff -uNrd ircd-ratbox-1.1rc4/src/s_user.c ircd-7+BgFree-p6/src/s_user.c
--- ircd-ratbox-1.1rc4/src/s_user.c	Wed Feb  5 20:47:39 2003
+++ ircd-7+BgFree-p6/src/s_user.c	Sat Apr  5 18:27:54 2003
@@ -227,6 +227,12 @@
 	sendto_one(source_p, form_str(RPL_GLOBALUSERS), me.name, source_p->name,
 		   Count.total, Count.max_tot);
 
+ sendto_one(source_p, form_str(RPL_IDENTUSERS), me.name, source_p->name,
+             CurrentIdentUsers, MaxIdentUsers);
+
+  sendto_one(source_p, form_str(RPL_OSIDUSERS), me.name, source_p->name,
+             CurrentOSidUsers, MaxOSidUsers);
+
 	if(!ConfigServerHide.hide_servers || IsOper(source_p))
 		sendto_one(source_p, form_str(RPL_STATSCONN), me.name, source_p->name,
 			   MaxConnectionCount, MaxClientCount, Count.totalrestartcount);
diff -uNrd ircd-ratbox-1.1rc4/src/y.tab.c ircd-7+BgFree-p6/src/y.tab.c
--- ircd-ratbox-1.1rc4/src/y.tab.c	Wed Feb 19 08:05:28 2003
+++ ircd-7+BgFree-p6/src/y.tab.c	Wed Dec 31 19:00:00 1969
@@ -1,1539 +0,0 @@
-/* A Bison parser, made by GNU Bison 1.875a.  */
-
-/* Skeleton parser for Yacc-like parsing with Bison,
-   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003 Free Software Foundation, Inc.
-
-   This program is free software; you can redistribute it and/or modify
-   it under the terms of the GNU General Public License as published by
-   the Free Software Foundation; either version 2, or (at your option)
-   any later version.
-
-   This program is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-   GNU General Public License for more details.
-
-   You should have received a copy of the GNU General Public License
-   along with this program; if not, write to the Free Software
-   Foundation, Inc., 59 Temple Place - Suite 330,
-   Boston, MA 02111-1307, USA.  */
-
-/* As a special exception, when this file is copied by Bison into a
-   Bison output file, you may use that output file without restriction.
-   This special exception was added by the Free Software Foundation
-   in version 1.24 of Bison.  */
-
-/* Written by Richard Stallman by simplifying the original so called
-   ``semantic'' parser.  */
-
-/* All symbols defined below should begin with yy or YY, to avoid
-   infringing on user name space.  This should be done even for local
-   variables, as they might otherwise be expanded by user macros.
-   There are some unavoidable exceptions within include files to
-   define necessary library symbols; they are noted "INFRINGES ON
-   USER NAME SPACE" below.  */
-
-/* Identify Bison output.  */
-#define YYBISON 1
-
-/* Skeleton name.  */
-#define YYSKELETON_NAME "yacc.c"
-
-/* Pure parsers.  */
-#define YYPURE 0
-
-/* Using locations.  */
-#define YYLSP_NEEDED 0
-
-
-
-/* Tokens.  */
-#ifndef YYTOKENTYPE
-# define YYTOKENTYPE
-   /* Put the tokens into the symbol table, so that GDB and other debuggers
-      know about them.  */
-   enum yytokentype {
-     LOADMODULE = 258,
-     TWODOTS = 259,
-     QSTRING = 260,
-     STRING = 261,
-     NUMBER = 262
-   };
-#endif
-#define LOADMODULE 258
-#define TWODOTS 259
-#define QSTRING 260
-#define STRING 261
-#define NUMBER 262
-
-
-
-
-/* Copy the first part of user declarations.  */
-#line 6 "ircd_parser.y"
-
-#include <sys/types.h>
-#include <sys/stat.h>
-
-#include <netinet/in.h>
-
-#include <string.h>
-#include <stdlib.h>
-#include <stdarg.h>
-#include <stdio.h>
-#define WE_ARE_MEMORY_C
-#include "stdinc.h"
-#include "setup.h"
-#include "common.h"
-#include "ircd_defs.h"
-#include "config.h"
-#include "client.h"
-#include "modules.h"
-#include "newconf.h"
-
-#define YY_NO_UNPUT
-
-int yyparse();
-int yyerror(const char *);
-int yylex();
-
-static time_t conf_find_time(char*);
-
-static struct {
-	const char *	name;
-	const char *	plural;
-	time_t 	val;
-} times[] = {
-	{"second",     "seconds",    1},
-	{"minute",     "minutes",    60},
-	{"hour",       "hours",      60 * 60},
-	{"day",        "days",       60 * 60 * 24},
-	{"week",       "weeks",      60 * 60 * 24 * 7},
-	{"fortnight",  "fortnights", 60 * 60 * 24 * 14},
-	{"month",      "months",     60 * 60 * 24 * 7 * 4},
-	{"year",       "years",      60 * 60 * 24 * 365},
-	/* ok-- we now do sizes here too. they aren't times, but 
-	   it's close enough */
-	{"byte",	"bytes",	1},
-	{"kb",		NULL,		1024},
-	{"kbyte",	"kbytes",	1024},
-	{"kilobyte",	"kilobytes",	1024},
-	{"mb",		NULL,		1024 * 1024},
-	{"mbyte",	"mbytes",	1024 * 1024},
-	{"megabyte",	"megabytes",	1024 * 1024},
-	{NULL},
-};
-
-time_t conf_find_time(char *name)
-{
-  int i;
-
-  for (i = 0; times[i].name; i++)
-    {
-      if (strcasecmp(times[i].name, name) == 0 ||
-	  (times[i].plural && strcasecmp(times[i].plural, name) == 0))
-	return times[i].val;
-    }
-
-  return 0;
-}
-
-static struct
-{
-	const char *word;
-	int yesno;
-} yesno[] = {
-	{"yes",		1},
-	{"no",		0},
-	{"true",	1},
-	{"false",	0},
-	{"on",		1},
-	{"off",		0},
-	{NULL,		0}
-};
-
-static int	conf_get_yesno_value(char *str)
-{
-	int i;
-
-	for (i = 0; yesno[i].word; i++)
-	{
-		if (strcasecmp(str, yesno[i].word) == 0)
-		{
-			return yesno[i].yesno;
-		}
-	}
-
-	return -1;
-}
-
-static void	free_cur_list(conf_parm_t* list)
-{
-	switch (list->type & CF_MTYPE)
-	{
-		case CF_STRING:
-		case CF_QSTRING:
-			MyFree(list->v.string);
-			break;
-		case CF_LIST:
-			free_cur_list(list->v.list);
-			break;
-		default: break;
-	}
-
-	if (list->next)
-		free_cur_list(list->next);
-}
-
-		
-conf_parm_t *	cur_list = NULL;
-
-static void	add_cur_list_cpt(conf_parm_t *new)
-{
-	if (cur_list == NULL)
-	{
-		cur_list = MyMalloc(sizeof(conf_parm_t));
-		memset(cur_list, 0, sizeof(conf_parm_t));
-		cur_list->type |= CF_FLIST;
-		cur_list->v.list = new;
-	}
-	else
-	{
-		new->next = cur_list->v.list;
-		cur_list->v.list = new;
-	}
-}
-
-static void	add_cur_list(int type, char *str, int number)
-{
-	conf_parm_t *new;
-
-	new = MyMalloc(sizeof(conf_parm_t));
-	new->next = NULL;
-	new->type = type;
-
-	switch(type)
-	{
-	case CF_INT:
-	case CF_TIME:
-	case CF_YESNO:
-		new->v.number = number;
-		break;
-	case CF_STRING:
-	case CF_QSTRING:
-		DupString(new->v.string, str);
-		break;
-	}
-
-	add_cur_list_cpt(new);
-}
-
-
-
-
-/* Enabling traces.  */
-#ifndef YYDEBUG
-# define YYDEBUG 0
-#endif
-
-/* Enabling verbose error messages.  */
-#ifdef YYERROR_VERBOSE
-# undef YYERROR_VERBOSE
-# define YYERROR_VERBOSE 1
-#else
-# define YYERROR_VERBOSE 0
-#endif
-
-#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
-#line 166 "ircd_parser.y"
-typedef union YYSTYPE {
-	int 		number;
-	char 		string[IRCD_BUFSIZE + 1];
-	conf_parm_t *	conf_parm;
-} YYSTYPE;
-/* Line 191 of yacc.c.  */
-#line 256 "y.tab.c"
-# define yystype YYSTYPE /* obsolescent; will be withdrawn */
-# define YYSTYPE_IS_DECLARED 1
-# define YYSTYPE_IS_TRIVIAL 1
-#endif
-
-
-
-/* Copy the second part of user declarations.  */
-
-
-/* Line 214 of yacc.c.  */
-#line 268 "y.tab.c"
-
-#if ! defined (yyoverflow) || YYERROR_VERBOSE
-
-/* The parser invokes alloca or malloc; define the necessary symbols.  */
-
-# if YYSTACK_USE_ALLOCA
-#  define YYSTACK_ALLOC alloca
-# else
-#  ifndef YYSTACK_USE_ALLOCA
-#   if defined (alloca) || defined (_ALLOCA_H)
-#    define YYSTACK_ALLOC alloca
-#   else
-#    ifdef __GNUC__
-#     define YYSTACK_ALLOC __builtin_alloca
-#    endif
-#   endif
-#  endif
-# endif
-
-# ifdef YYSTACK_ALLOC
-   /* Pacify GCC's `empty if-body' warning. */
-#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
-# else
-#  if defined (__STDC__) || defined (__cplusplus)
-#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
-#   define YYSIZE_T size_t
-#  endif
-#  define YYSTACK_ALLOC malloc
-#  define YYSTACK_FREE free
-# endif
-#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */
-
-
-#if (! defined (yyoverflow) \
-     && (! defined (__cplusplus) \
-	 || (YYSTYPE_IS_TRIVIAL)))
-
-/* A type that is properly aligned for any stack member.  */
-union yyalloc
-{
-  short yyss;
-  YYSTYPE yyvs;
-  };
-
-/* The size of the maximum gap between one aligned stack and the next.  */
-# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)
-
-/* The size of an array large to enough to hold all stacks, each with
-   N elements.  */
-# define YYSTACK_BYTES(N) \
-     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
-      + YYSTACK_GAP_MAXIMUM)
-
-/* Copy COUNT objects from FROM to TO.  The source and destination do
-   not overlap.  */
-# ifndef YYCOPY
-#  if 1 < __GNUC__
-#   define YYCOPY(To, From, Count) \
-      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
-#  else
-#   define YYCOPY(To, From, Count)		\
-      do					\
-	{					\
-	  register YYSIZE_T yyi;		\
-	  for (yyi = 0; yyi < (Count); yyi++)	\
-	    (To)[yyi] = (From)[yyi];		\
-	}					\
-      while (0)
-#  endif
-# endif
-
-/* Relocate STACK from its old location to the new one.  The
-   local variables YYSIZE and YYSTACKSIZE give the old and new number of
-   elements in the stack, and YYPTR gives the new location of the
-   stack.  Advance YYPTR to a properly aligned location for the next
-   stack.  */
-# define YYSTACK_RELOCATE(Stack)					\
-    do									\
-      {									\
-	YYSIZE_T yynewbytes;						\
-	YYCOPY (&yyptr->Stack, Stack, yysize);				\
-	Stack = &yyptr->Stack;						\
-	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
-	yyptr += yynewbytes / sizeof (*yyptr);				\
-      }									\
-    while (0)
-
-#endif
-
-#if defined (__STDC__) || defined (__cplusplus)
-   typedef signed char yysigned_char;
-#else
-   typedef short yysigned_char;
-#endif
-
-/* YYFINAL -- State number of the termination state. */
-#define YYFINAL  3
-/* YYLAST -- Last index in YYTABLE.  */
-#define YYLAST   42
-
-/* YYNTOKENS -- Number of terminals. */
-#define YYNTOKENS  13
-/* YYNNTS -- Number of nonterminals. */
-#define YYNNTS  17
-/* YYNRULES -- Number of rules. */
-#define YYNRULES  29
-/* YYNRULES -- Number of states. */
-#define YYNSTATES  45
-
-/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
-#define YYUNDEFTOK  2
-#define YYMAXUTOK   262
-
-#define YYTRANSLATE(YYX) 						\
-  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)
-
-/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
-static const unsigned char yytranslate[] =
-{
-       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
-       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
-       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
-       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
-       2,     2,     2,     2,    12,     2,     2,     2,     2,     2,
-       2,     2,     2,     2,     2,     2,     2,     2,     2,    10,
-       2,    11,     2,     2,     2,     2,     2,     2,     2,     2,
-       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
-       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
-       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
-       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
-       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
-       2,     2,     2,     8,     2,     9,     2,     2,     2,     2,
-       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
-       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
-       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
-       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
-       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
-       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
-       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
-       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
-       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
-       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
-       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
-       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
-       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
-       5,     6,     7
-};
-
-#if YYDEBUG
-/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
-   YYRHS.  */
-static const unsigned char yyprhs[] =
-{
-       0,     0,     3,     4,     7,     9,    11,    13,    14,    21,
-      22,    30,    33,    35,    40,    44,    46,    48,    52,    54,
-      56,    58,    60,    61,    66,    68,    70,    72,    75,    78
-};
-
-/* YYRHS -- A `-1'-separated list of the rules' RHS. */
-static const yysigned_char yyrhs[] =
-{
-      14,     0,    -1,    -1,    14,    15,    -1,     1,    -1,    16,
-      -1,    24,    -1,    -1,    27,    17,     8,    19,     9,    10,
-      -1,    -1,    27,    26,    18,     8,    19,     9,    10,    -1,
-      19,    20,    -1,    20,    -1,    27,    11,    21,    10,    -1,
-      21,    12,    22,    -1,    22,    -1,    23,    -1,    23,     4,
-      23,    -1,    26,    -1,    29,    -1,    28,    -1,    27,    -1,
-      -1,     3,     5,    25,    10,    -1,     5,    -1,     6,    -1,
-       7,    -1,    28,    27,    -1,    29,    29,    -1,    29,    28,
-      -1
-};
-
-/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
-static const unsigned short yyrline[] =
-{
-       0,   185,   185,   186,   187,   190,   191,   195,   194,   204,
-     203,   214,   215,   218,   226,   227,   230,   234,   255,   262,
-     269,   276,   300,   299,   308,   309,   310,   312,   324,   328
-};
-#endif
-
-#if YYDEBUG || YYERROR_VERBOSE
-/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
-   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
-static const char *const yytname[] =
-{
-  "$end", "error", "$undefined", "LOADMODULE", "TWODOTS", "QSTRING", 
-  "STRING", "NUMBER", "'{'", "'}'", "';'", "'='", "','", "$accept", 
-  "conf", "conf_item", "block", "@1", "@2", "block_items", "block_item", 
-  "itemlist", "single", "oneitem", "loadmodule", "@3", "qstring", 
-  "string", "number", "timespec", 0
-};
-#endif
-
-# ifdef YYPRINT
-/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
-   token YYLEX-NUM.  */
-static const unsigned short yytoknum[] =
-{
-       0,   256,   257,   258,   259,   260,   261,   262,   123,   125,
-      59,    61,    44
-};
-# endif
-
-/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
-static const unsigned char yyr1[] =
-{
-       0,    13,    14,    14,    14,    15,    15,    17,    16,    18,
-      16,    19,    19,    20,    21,    21,    22,    22,    23,    23,
-      23,    23,    25,    24,    26,    27,    28,    29,    29,    29
-};
-
-/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
-static const unsigned char yyr2[] =
-{
-       0,     2,     0,     2,     1,     1,     1,     0,     6,     0,
-       7,     2,     1,     4,     3,     1,     1,     3,     1,     1,
-       1,     1,     0,     4,     1,     1,     1,     2,     2,     2
-};
-
-/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
-   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
-   means the default is an error.  */
-static const unsigned char yydefact[] =
-{
-       0,     4,     0,     1,     0,    25,     3,     5,     6,     7,
-      22,    24,     0,     9,     0,     0,     0,    23,     0,    12,
-       0,     0,     0,    11,     0,     0,     8,    26,     0,    15,
-      16,    18,    21,    20,    19,     0,    13,     0,     0,    27,
-      29,    28,    10,    14,    17
-};
-
-/* YYDEFGOTO[NTERM-NUM]. */
-static const yysigned_char yydefgoto[] =
-{
-      -1,     2,     6,     7,    12,    16,    18,    19,    28,    29,
-      30,     8,    14,    31,    20,    33,    34
-};
-
-/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
-   STATE-NUM.  */
-#define YYPACT_NINF -33
-static const yysigned_char yypact[] =
-{
-      11,   -33,    13,   -33,     2,   -33,   -33,   -33,   -33,    16,
-     -33,   -33,    18,   -33,    19,    22,    24,   -33,     9,   -33,
-      23,    22,    20,   -33,    -1,    14,   -33,   -33,    15,   -33,
-      29,   -33,   -33,    22,    17,    27,   -33,    -1,    -1,   -33,
-      22,    17,   -33,   -33,   -33
-};
-
-/* YYPGOTO[NTERM-NUM].  */
-static const yysigned_char yypgoto[] =
-{
-     -33,   -33,   -33,   -33,   -33,   -33,    21,   -17,   -33,     3,
-       1,   -33,   -33,    32,    -2,   -32,   -31
-};
-
-/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
-   positive, shift that token.  If negative, reduce the rule which
-   number is the opposite.  If zero, do what YYDEFACT says.
-   If YYTABLE_NINF, syntax error.  */
-#define YYTABLE_NINF -3
-static const yysigned_char yytable[] =
-{
-       9,    23,    40,    41,    11,     5,    27,    10,    23,    40,
-      41,    -2,     1,     3,    -2,     5,     4,    -2,    22,     5,
-       5,    11,    32,    35,    27,    36,    15,    37,     5,    17,
-      26,    39,    21,    38,    24,    32,    32,    42,    39,    44,
-      43,    13,    25
-};
-
-static const unsigned char yycheck[] =
-{
-       2,    18,    34,    34,     5,     6,     7,     5,    25,    41,
-      41,     0,     1,     0,     3,     6,     3,     6,     9,     6,
-       6,     5,    24,     9,     7,    10,     8,    12,     6,    10,
-      10,    33,     8,     4,    11,    37,    38,    10,    40,    38,
-      37,     9,    21
-};
-
-/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
-   symbol of state STATE-NUM.  */
-static const unsigned char yystos[] =
-{
-       0,     1,    14,     0,     3,     6,    15,    16,    24,    27,
-       5,     5,    17,    26,    25,     8,    18,    10,    19,    20,
-      27,     8,     9,    20,    11,    19,    10,     7,    21,    22,
-      23,    26,    27,    28,    29,     9,    10,    12,     4,    27,
-      28,    29,    10,    22,    23
-};
-
-#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
-# define YYSIZE_T __SIZE_TYPE__
-#endif
-#if ! defined (YYSIZE_T) && defined (size_t)
-# define YYSIZE_T size_t
-#endif
-#if ! defined (YYSIZE_T)
-# if defined (__STDC__) || defined (__cplusplus)
-#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
-#  define YYSIZE_T size_t
-# endif
-#endif
-#if ! defined (YYSIZE_T)
-# define YYSIZE_T unsigned int
-#endif
-
-#define yyerrok		(yyerrstatus = 0)
-#define yyclearin	(yychar = YYEMPTY)
-#define YYEMPTY		(-2)
-#define YYEOF		0
-
-#define YYACCEPT	goto yyacceptlab
-#define YYABORT		goto yyabortlab
-#define YYERROR		goto yyerrlab1
-
-
-/* Like YYERROR except do call yyerror.  This remains here temporarily
-   to ease the transition to the new meaning of YYERROR, for GCC.
-   Once GCC version 2 has supplanted version 1, this can go.  */
-
-#define YYFAIL		goto yyerrlab
-
-#define YYRECOVERING()  (!!yyerrstatus)
-
-#define YYBACKUP(Token, Value)					\
-do								\
-  if (yychar == YYEMPTY && yylen == 1)				\
-    {								\
-      yychar = (Token);						\
-      yylval = (Value);						\
-      yytoken = YYTRANSLATE (yychar);				\
-      YYPOPSTACK;						\
-      goto yybackup;						\
-    }								\
-  else								\
-    { 								\
-      yyerror ("syntax error: cannot back up");\
-      YYERROR;							\
-    }								\
-while (0)
-
-#define YYTERROR	1
-#define YYERRCODE	256
-
-/* YYLLOC_DEFAULT -- Compute the default location (before the actions
-   are run).  */
-
-#ifndef YYLLOC_DEFAULT
-# define YYLLOC_DEFAULT(Current, Rhs, N)         \
-  Current.first_line   = Rhs[1].first_line;      \
-  Current.first_column = Rhs[1].first_column;    \
-  Current.last_line    = Rhs[N].last_line;       \
-  Current.last_column  = Rhs[N].last_column;
-#endif
-
-/* YYLEX -- calling `yylex' with the right arguments.  */
-
-#ifdef YYLEX_PARAM
-# define YYLEX yylex (YYLEX_PARAM)
-#else
-# define YYLEX yylex ()
-#endif
-
-/* Enable debugging if requested.  */
-#if YYDEBUG
-
-# ifndef YYFPRINTF
-#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
-#  define YYFPRINTF fprintf
-# endif
-
-# define YYDPRINTF(Args)			\
-do {						\
-  if (yydebug)					\
-    YYFPRINTF Args;				\
-} while (0)
-
-# define YYDSYMPRINT(Args)			\
-do {						\
-  if (yydebug)					\
-    yysymprint Args;				\
-} while (0)
-
-# define YYDSYMPRINTF(Title, Token, Value, Location)		\
-do {								\
-  if (yydebug)							\
-    {								\
-      YYFPRINTF (stderr, "%s ", Title);				\
-      yysymprint (stderr, 					\
-                  Token, Value);	\
-      YYFPRINTF (stderr, "\n");					\
-    }								\
-} while (0)
-
-/*------------------------------------------------------------------.
-| yy_stack_print -- Print the state stack from its BOTTOM up to its |
-| TOP (cinluded).                                                   |
-`------------------------------------------------------------------*/
-
-#if defined (__STDC__) || defined (__cplusplus)
-static void
-yy_stack_print (short *bottom, short *top)
-#else
-static void
-yy_stack_print (bottom, top)
-    short *bottom;
-    short *top;
-#endif
-{
-  YYFPRINTF (stderr, "Stack now");
-  for (/* Nothing. */; bottom <= top; ++bottom)
-    YYFPRINTF (stderr, " %d", *bottom);
-  YYFPRINTF (stderr, "\n");
-}
-
-# define YY_STACK_PRINT(Bottom, Top)				\
-do {								\
-  if (yydebug)							\
-    yy_stack_print ((Bottom), (Top));				\
-} while (0)
-
-
-/*------------------------------------------------.
-| Report that the YYRULE is going to be reduced.  |
-`------------------------------------------------*/
-
-#if defined (__STDC__) || defined (__cplusplus)
-static void
-yy_reduce_print (int yyrule)
-#else
-static void
-yy_reduce_print (yyrule)
-    int yyrule;
-#endif
-{
-  int yyi;
-  unsigned int yylineno = yyrline[yyrule];
-  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
-             yyrule - 1, yylineno);
-  /* Print the symbols being reduced, and their result.  */
-  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
-    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
-  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
-}
-
-# define YY_REDUCE_PRINT(Rule)		\
-do {					\
-  if (yydebug)				\
-    yy_reduce_print (Rule);		\
-} while (0)
-
-/* Nonzero means print parse trace.  It is left uninitialized so that
-   multiple parsers can coexist.  */
-int yydebug;
-#else /* !YYDEBUG */
-# define YYDPRINTF(Args)
-# define YYDSYMPRINT(Args)
-# define YYDSYMPRINTF(Title, Token, Value, Location)
-# define YY_STACK_PRINT(Bottom, Top)
-# define YY_REDUCE_PRINT(Rule)
-#endif /* !YYDEBUG */
-
-
-/* YYINITDEPTH -- initial size of the parser's stacks.  */
-#ifndef	YYINITDEPTH
-# define YYINITDEPTH 200
-#endif
-
-/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
-   if the built-in stack extension method is used).
-
-   Do not make this value too large; the results are undefined if
-   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
-   evaluated with infinite-precision integer arithmetic.  */
-
-#if YYMAXDEPTH == 0
-# undef YYMAXDEPTH
-#endif
-
-#ifndef YYMAXDEPTH
-# define YYMAXDEPTH 10000
-#endif
-
-
-
-#if YYERROR_VERBOSE
-
-# ifndef yystrlen
-#  if defined (__GLIBC__) && defined (_STRING_H)
-#   define yystrlen strlen
-#  else
-/* Return the length of YYSTR.  */
-static YYSIZE_T
-#   if defined (__STDC__) || defined (__cplusplus)
-yystrlen (const char *yystr)
-#   else
-yystrlen (yystr)
-     const char *yystr;
-#   endif
-{
-  register const char *yys = yystr;
-
-  while (*yys++ != '\0')
-    continue;
-
-  return yys - yystr - 1;
-}
-#  endif
-# endif
-
-# ifndef yystpcpy
-#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
-#   define yystpcpy stpcpy
-#  else
-/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
-   YYDEST.  */
-static char *
-#   if defined (__STDC__) || defined (__cplusplus)
-yystpcpy (char *yydest, const char *yysrc)
-#   else
-yystpcpy (yydest, yysrc)
-     char *yydest;
-     const char *yysrc;
-#   endif
-{
-  register char *yyd = yydest;
-  register const char *yys = yysrc;
-
-  while ((*yyd++ = *yys++) != '\0')
-    continue;
-
-  return yyd - 1;
-}
-#  endif
-# endif
-
-#endif /* !YYERROR_VERBOSE */
-
-
-
-#if YYDEBUG
-/*--------------------------------.
-| Print this symbol on YYOUTPUT.  |
-`--------------------------------*/
-
-#if defined (__STDC__) || defined (__cplusplus)
-static void
-yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
-#else
-static void
-yysymprint (yyoutput, yytype, yyvaluep)
-    FILE *yyoutput;
-    int yytype;
-    YYSTYPE *yyvaluep;
-#endif
-{
-  /* Pacify ``unused variable'' warnings.  */
-  (void) yyvaluep;
-
-  if (yytype < YYNTOKENS)
-    {
-      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
-# ifdef YYPRINT
-      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
-# endif
-    }
-  else
-    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);
-
-  switch (yytype)
-    {
-      default:
-        break;
-    }
-  YYFPRINTF (yyoutput, ")");
-}
-
-#endif /* ! YYDEBUG */
-/*-----------------------------------------------.
-| Release the memory associated to this symbol.  |
-`-----------------------------------------------*/
-
-#if defined (__STDC__) || defined (__cplusplus)
-static void
-yydestruct (int yytype, YYSTYPE *yyvaluep)
-#else
-static void
-yydestruct (yytype, yyvaluep)
-    int yytype;
-    YYSTYPE *yyvaluep;
-#endif
-{
-  /* Pacify ``unused variable'' warnings.  */
-  (void) yyvaluep;
-
-  switch (yytype)
-    {
-
-      default:
-        break;
-    }
-}
-
-
-/* Prevent warnings from -Wmissing-prototypes.  */
-
-#ifdef YYPARSE_PARAM
-# if defined (__STDC__) || defined (__cplusplus)
-int yyparse (void *YYPARSE_PARAM);
-# else
-int yyparse ();
-# endif
-#else /* ! YYPARSE_PARAM */
-#if defined (__STDC__) || defined (__cplusplus)
-int yyparse (void);
-#else
-int yyparse ();
-#endif
-#endif /* ! YYPARSE_PARAM */
-
-
-
-/* The lookahead symbol.  */
-int yychar;
-
-/* The semantic value of the lookahead symbol.  */
-YYSTYPE yylval;
-
-/* Number of syntax errors so far.  */
-int yynerrs;
-
-
-
-/*----------.
-| yyparse.  |
-`----------*/
-
-#ifdef YYPARSE_PARAM
-# if defined (__STDC__) || defined (__cplusplus)
-int yyparse (void *YYPARSE_PARAM)
-# else
-int yyparse (YYPARSE_PARAM)
-  void *YYPARSE_PARAM;
-# endif
-#else /* ! YYPARSE_PARAM */
-#if defined (__STDC__) || defined (__cplusplus)
-int
-yyparse (void)
-#else
-int
-yyparse ()
-
-#endif
-#endif
-{
-  
-  register int yystate;
-  register int yyn;
-  int yyresult;
-  /* Number of tokens to shift before error messages enabled.  */
-  int yyerrstatus;
-  /* Lookahead token as an internal (translated) token number.  */
-  int yytoken = 0;
-
-  /* Three stacks and their tools:
-     `yyss': related to states,
-     `yyvs': related to semantic values,
-     `yyls': related to locations.
-
-     Refer to the stacks thru separate pointers, to allow yyoverflow
-     to reallocate them elsewhere.  */
-
-  /* The state stack.  */
-  short	yyssa[YYINITDEPTH];
-  short *yyss = yyssa;
-  register short *yyssp;
-
-  /* The semantic value stack.  */
-  YYSTYPE yyvsa[YYINITDEPTH];
-  YYSTYPE *yyvs = yyvsa;
-  register YYSTYPE *yyvsp;
-
-
-
-#define YYPOPSTACK   (yyvsp--, yyssp--)
-
-  YYSIZE_T yystacksize = YYINITDEPTH;
-
-  /* The variables used to return semantic value and location from the
-     action routines.  */
-  YYSTYPE yyval;
-
-
-  /* When reducing, the number of symbols on the RHS of the reduced
-     rule.  */
-  int yylen;
-
-  YYDPRINTF ((stderr, "Starting parse\n"));
-
-  yystate = 0;
-  yyerrstatus = 0;
-  yynerrs = 0;
-  yychar = YYEMPTY;		/* Cause a token to be read.  */
-
-  /* Initialize stack pointers.
-     Waste one element of value and location stack
-     so that they stay on the same level as the state stack.
-     The wasted elements are never initialized.  */
-
-  yyssp = yyss;
-  yyvsp = yyvs;
-
-  goto yysetstate;
-
-/*------------------------------------------------------------.
-| yynewstate -- Push a new state, which is found in yystate.  |
-`------------------------------------------------------------*/
- yynewstate:
-  /* In all cases, when you get here, the value and location stacks
-     have just been pushed. so pushing a state here evens the stacks.
-     */
-  yyssp++;
-
- yysetstate:
-  *yyssp = yystate;
-
-  if (yyss + yystacksize - 1 <= yyssp)
-    {
-      /* Get the current used size of the three stacks, in elements.  */
-      YYSIZE_T yysize = yyssp - yyss + 1;
-
-#ifdef yyoverflow
-      {
-	/* Give user a chance to reallocate the stack. Use copies of
-	   these so that the &'s don't force the real ones into
-	   memory.  */
-	YYSTYPE *yyvs1 = yyvs;
-	short *yyss1 = yyss;
-
-
-	/* Each stack pointer address is followed by the size of the
-	   data in use in that stack, in bytes.  This used to be a
-	   conditional around just the two extra args, but that might
-	   be undefined if yyoverflow is a macro.  */
-	yyoverflow ("parser stack overflow",
-		    &yyss1, yysize * sizeof (*yyssp),
-		    &yyvs1, yysize * sizeof (*yyvsp),
-
-		    &yystacksize);
-
-	yyss = yyss1;
-	yyvs = yyvs1;
-      }
-#else /* no yyoverflow */
-# ifndef YYSTACK_RELOCATE
-      goto yyoverflowlab;
-# else
-      /* Extend the stack our own way.  */
-      if (YYMAXDEPTH <= yystacksize)
-	goto yyoverflowlab;
-      yystacksize *= 2;
-      if (YYMAXDEPTH < yystacksize)
-	yystacksize = YYMAXDEPTH;
-
-      {
-	short *yyss1 = yyss;
-	union yyalloc *yyptr =
-	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
-	if (! yyptr)
-	  goto yyoverflowlab;
-	YYSTACK_RELOCATE (yyss);
-	YYSTACK_RELOCATE (yyvs);
-
-#  undef YYSTACK_RELOCATE
-	if (yyss1 != yyssa)
-	  YYSTACK_FREE (yyss1);
-      }
-# endif
-#endif /* no yyoverflow */
-
-      yyssp = yyss + yysize - 1;
-      yyvsp = yyvs + yysize - 1;
-
-
-      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
-		  (unsigned long int) yystacksize));
-
-      if (yyss + yystacksize - 1 <= yyssp)
-	YYABORT;
-    }
-
-  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
-
-  goto yybackup;
-
-/*-----------.
-| yybackup.  |
-`-----------*/
-yybackup:
-
-/* Do appropriate processing given the current state.  */
-/* Read a lookahead token if we need one and don't already have one.  */
-/* yyresume: */
-
-  /* First try to decide what to do without reference to lookahead token.  */
-
-  yyn = yypact[yystate];
-  if (yyn == YYPACT_NINF)
-    goto yydefault;
-
-  /* Not known => get a lookahead token if don't already have one.  */
-
-  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
-  if (yychar == YYEMPTY)
-    {
-      YYDPRINTF ((stderr, "Reading a token: "));
-      yychar = YYLEX;
-    }
-
-  if (yychar <= YYEOF)
-    {
-      yychar = yytoken = YYEOF;
-      YYDPRINTF ((stderr, "Now at end of input.\n"));
-    }
-  else
-    {
-      yytoken = YYTRANSLATE (yychar);
-      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
-    }
-
-  /* If the proper action on seeing token YYTOKEN is to reduce or to
-     detect an error, take that action.  */
-  yyn += yytoken;
-  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
-    goto yydefault;
-  yyn = yytable[yyn];
-  if (yyn <= 0)
-    {
-      if (yyn == 0 || yyn == YYTABLE_NINF)
-	goto yyerrlab;
-      yyn = -yyn;
-      goto yyreduce;
-    }
-
-  if (yyn == YYFINAL)
-    YYACCEPT;
-
-  /* Shift the lookahead token.  */
-  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));
-
-  /* Discard the token being shifted unless it is eof.  */
-  if (yychar != YYEOF)
-    yychar = YYEMPTY;
-
-  *++yyvsp = yylval;
-
-
-  /* Count tokens shifted since error; after three, turn off error
-     status.  */
-  if (yyerrstatus)
-    yyerrstatus--;
-
-  yystate = yyn;
-  goto yynewstate;
-
-
-/*-----------------------------------------------------------.
-| yydefault -- do the default action for the current state.  |
-`-----------------------------------------------------------*/
-yydefault:
-  yyn = yydefact[yystate];
-  if (yyn == 0)
-    goto yyerrlab;
-  goto yyreduce;
-
-
-/*-----------------------------.
-| yyreduce -- Do a reduction.  |
-`-----------------------------*/
-yyreduce:
-  /* yyn is the number of a rule to reduce with.  */
-  yylen = yyr2[yyn];
-
-  /* If YYLEN is nonzero, implement the default value of the action:
-     `$$ = $1'.
-
-     Otherwise, the following line sets YYVAL to garbage.
-     This behavior is undocumented and Bison
-     users should not rely upon it.  Assigning to YYVAL
-     unconditionally makes the parser a bit smaller, and it avoids a
-     GCC warning that YYVAL may be used uninitialized.  */
-  yyval = yyvsp[1-yylen];
-
-
-  YY_REDUCE_PRINT (yyn);
-  switch (yyn)
-    {
-        case 7:
-#line 195 "ircd_parser.y"
-    { 
-           conf_start_block(yyvsp[0].string, NULL);
-         }
-    break;
-
-  case 8:
-#line 199 "ircd_parser.y"
-    {
-	   if (conf_cur_block)
-           	conf_end_block(conf_cur_block);
-         }
-    break;
-
-  case 9:
-#line 204 "ircd_parser.y"
-    { 
-           conf_start_block(yyvsp[-1].string, yyvsp[0].string);
-         }
-    break;
-
-  case 10:
-#line 208 "ircd_parser.y"
-    {
-	   if (conf_cur_block)
-           	conf_end_block(conf_cur_block);
-         }
-    break;
-
-  case 13:
-#line 219 "ircd_parser.y"
-    {
-			conf_call_set(conf_cur_block, yyvsp[-3].string, cur_list, CF_LIST);
-			free_cur_list(cur_list);
-			cur_list = NULL;
-		}
-    break;
-
-  case 16:
-#line 231 "ircd_parser.y"
-    {
-		add_cur_list_cpt(yyvsp[0].conf_parm);
-	}
-    break;
-
-  case 17:
-#line 235 "ircd_parser.y"
-    {
-		/* "1 .. 5" meaning 1,2,3,4,5 - only valid for integers */
-		if ((yyvsp[-2].conf_parm->type & CF_MTYPE) != CF_INT ||
-		    (yyvsp[0].conf_parm->type & CF_MTYPE) != CF_INT)
-		{
-			conf_report_error("Both arguments in '..' notation must be integers.");
-			break;
-		}
-		else
-		{
-			int i;
-
-			for (i = yyvsp[-2].conf_parm->v.number; i <= yyvsp[0].conf_parm->v.number; i++)
-			{
-				add_cur_list(CF_INT, 0, i);
-			}
-		}
-	}
-    break;
-
-  case 18:
-#line 256 "ircd_parser.y"
-    {
-		yyval.conf_parm = MyMalloc(sizeof(conf_parm_t));
-		memset(yyval.conf_parm, 0, sizeof(conf_parm_t));
-		yyval.conf_parm->type = CF_QSTRING;
-		DupString(yyval.conf_parm->v.string, yyvsp[0].string);
-	    }
-    break;
-
-  case 19:
-#line 263 "ircd_parser.y"
-    {
-		yyval.conf_parm = MyMalloc(sizeof(conf_parm_t));
-		memset(yyval.conf_parm, 0, sizeof(conf_parm_t));
-		yyval.conf_parm->type = CF_TIME;
-		yyval.conf_parm->v.number = yyvsp[0].number;
-	    }
-    break;
-
-  case 20:
-#line 270 "ircd_parser.y"
-    {
-		yyval.conf_parm = MyMalloc(sizeof(conf_parm_t));
-		memset(yyval.conf_parm, 0, sizeof(conf_parm_t));
-		yyval.conf_parm->type = CF_INT;
-		yyval.conf_parm->v.number = yyvsp[0].number;
-	    }
-    break;
-
-  case 21:
-#line 277 "ircd_parser.y"
-    {
-		/* a 'string' could also be a yes/no value .. 
-		   so pass it as that, if so */
-		int val = conf_get_yesno_value(yyvsp[0].string);
-
-		yyval.conf_parm = MyMalloc(sizeof(conf_parm_t));
-		memset(yyval.conf_parm, 0, sizeof(conf_parm_t));
-
-		if (val != -1)
-		{
-			yyval.conf_parm->type = CF_YESNO;
-			yyval.conf_parm->v.number = val;
-		}
-		else
-		{
-			yyval.conf_parm->type = CF_STRING;
-			DupString(yyval.conf_parm->v.string, yyvsp[0].string);
-		}
-            }
-    break;
-
-  case 22:
-#line 300 "ircd_parser.y"
-    {
-#ifndef STATIC_MODULES
-	      load_one_module(yyvsp[0].string, 0);
-#endif
-	    }
-    break;
-
-  case 24:
-#line 308 "ircd_parser.y"
-    { strcpy(yyval.string, yyvsp[0].string); }
-    break;
-
-  case 25:
-#line 309 "ircd_parser.y"
-    { strcpy(yyval.string, yyvsp[0].string); }
-    break;
-
-  case 26:
-#line 310 "ircd_parser.y"
-    { yyval.number = yyvsp[0].number; }
-    break;
-
-  case 27:
-#line 313 "ircd_parser.y"
-    {
-			time_t t;
-
-			if ((t = conf_find_time(yyvsp[0].string)) == 0)
-			{
-				conf_report_error("Unrecognised time type/size '%s'", yyvsp[0].string);
-				t = 1;
-			}
-	    
-			yyval.number = yyvsp[-1].number * t;
-		}
-    break;
-
-  case 28:
-#line 325 "ircd_parser.y"
-    {
-			yyval.number = yyvsp[-1].number + yyvsp[0].number;
-		}
-    break;
-
-  case 29:
-#line 329 "ircd_parser.y"
-    {
-			yyval.number = yyvsp[-1].number + yyvsp[0].number;
-		}
-    break;
-
-
-    }
-
-/* Line 999 of yacc.c.  */
-#line 1346 "y.tab.c"
-
-  yyvsp -= yylen;
-  yyssp -= yylen;
-
-
-  YY_STACK_PRINT (yyss, yyssp);
-
-  *++yyvsp = yyval;
-
-
-  /* Now `shift' the result of the reduction.  Determine what state
-     that goes to, based on the state we popped back to and the rule
-     number reduced by.  */
-
-  yyn = yyr1[yyn];
-
-  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
-  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
-    yystate = yytable[yystate];
-  else
-    yystate = yydefgoto[yyn - YYNTOKENS];
-
-  goto yynewstate;
-
-
-/*------------------------------------.
-| yyerrlab -- here on detecting error |
-`------------------------------------*/
-yyerrlab:
-  /* If not already recovering from an error, report this error.  */
-  if (!yyerrstatus)
-    {
-      ++yynerrs;
-#if YYERROR_VERBOSE
-      yyn = yypact[yystate];
-
-      if (YYPACT_NINF < yyn && yyn < YYLAST)
-	{
-	  YYSIZE_T yysize = 0;
-	  int yytype = YYTRANSLATE (yychar);
-	  char *yymsg;
-	  int yyx, yycount;
-
-	  yycount = 0;
-	  /* Start YYX at -YYN if negative to avoid negative indexes in
-	     YYCHECK.  */
-	  for (yyx = yyn < 0 ? -yyn : 0;
-	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
-	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
-	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
-	  yysize += yystrlen ("syntax error, unexpected ") + 1;
-	  yysize += yystrlen (yytname[yytype]);
-	  yymsg = (char *) YYSTACK_ALLOC (yysize);
-	  if (yymsg != 0)
-	    {
-	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
-	      yyp = yystpcpy (yyp, yytname[yytype]);
-
-	      if (yycount < 5)
-		{
-		  yycount = 0;
-		  for (yyx = yyn < 0 ? -yyn : 0;
-		       yyx < (int) (sizeof (yytname) / sizeof (char *));
-		       yyx++)
-		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
-		      {
-			const char *yyq = ! yycount ? ", expecting " : " or ";
-			yyp = yystpcpy (yyp, yyq);
-			yyp = yystpcpy (yyp, yytname[yyx]);
-			yycount++;
-		      }
-		}
-	      yyerror (yymsg);
-	      YYSTACK_FREE (yymsg);
-	    }
-	  else
-	    yyerror ("syntax error; also virtual memory exhausted");
-	}
-      else
-#endif /* YYERROR_VERBOSE */
-	yyerror ("syntax error");
-    }
-
-
-
-  if (yyerrstatus == 3)
-    {
-      /* If just tried and failed to reuse lookahead token after an
-	 error, discard it.  */
-
-      /* Return failure if at end of input.  */
-      if (yychar == YYEOF)
-        {
-	  /* Pop the error token.  */
-          YYPOPSTACK;
-	  /* Pop the rest of the stack.  */
-	  while (yyss < yyssp)
-	    {
-	      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
-	      yydestruct (yystos[*yyssp], yyvsp);
-	      YYPOPSTACK;
-	    }
-	  YYABORT;
-        }
-
-      YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
-      yydestruct (yytoken, &yylval);
-      yychar = YYEMPTY;
-
-    }
-
-  /* Else will try to reuse lookahead token after shifting the error
-     token.  */
-  goto yyerrlab1;
-
-
-/*----------------------------------------------------.
-| yyerrlab1 -- error raised explicitly by an action.  |
-`----------------------------------------------------*/
-yyerrlab1:
-  yyerrstatus = 3;	/* Each real token shifted decrements this.  */
-
-  for (;;)
-    {
-      yyn = yypact[yystate];
-      if (yyn != YYPACT_NINF)
-	{
-	  yyn += YYTERROR;
-	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
-	    {
-	      yyn = yytable[yyn];
-	      if (0 < yyn)
-		break;
-	    }
-	}
-
-      /* Pop the current state because it cannot handle the error token.  */
-      if (yyssp == yyss)
-	YYABORT;
-
-      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
-      yydestruct (yystos[yystate], yyvsp);
-      yyvsp--;
-      yystate = *--yyssp;
-
-      YY_STACK_PRINT (yyss, yyssp);
-    }
-
-  if (yyn == YYFINAL)
-    YYACCEPT;
-
-  YYDPRINTF ((stderr, "Shifting error token, "));
-
-  *++yyvsp = yylval;
-
-
-  yystate = yyn;
-  goto yynewstate;
-
-
-/*-------------------------------------.
-| yyacceptlab -- YYACCEPT comes here.  |
-`-------------------------------------*/
-yyacceptlab:
-  yyresult = 0;
-  goto yyreturn;
-
-/*-----------------------------------.
-| yyabortlab -- YYABORT comes here.  |
-`-----------------------------------*/
-yyabortlab:
-  yyresult = 1;
-  goto yyreturn;
-
-#ifndef yyoverflow
-/*----------------------------------------------.
-| yyoverflowlab -- parser overflow comes here.  |
-`----------------------------------------------*/
-yyoverflowlab:
-  yyerror ("parser stack overflow");
-  yyresult = 2;
-  /* Fall through.  */
-#endif
-
-yyreturn:
-#ifndef yyoverflow
-  if (yyss != yyssa)
-    YYSTACK_FREE (yyss);
-#endif
-  return yyresult;
-}
-
-
-
diff -uNrd ircd-ratbox-1.1rc4/src/y.tab.h ircd-7+BgFree-p6/src/y.tab.h
--- ircd-ratbox-1.1rc4/src/y.tab.h	Wed Feb 19 08:05:28 2003
+++ ircd-7+BgFree-p6/src/y.tab.h	Wed Dec 31 19:00:00 1969
@@ -1,65 +0,0 @@
-/* A Bison parser, made by GNU Bison 1.875a.  */
-
-/* Skeleton parser for Yacc-like parsing with Bison,
-   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003 Free Software Foundation, Inc.
-
-   This program is free software; you can redistribute it and/or modify
-   it under the terms of the GNU General Public License as published by
-   the Free Software Foundation; either version 2, or (at your option)
-   any later version.
-
-   This program is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-   GNU General Public License for more details.
-
-   You should have received a copy of the GNU General Public License
-   along with this program; if not, write to the Free Software
-   Foundation, Inc., 59 Temple Place - Suite 330,
-   Boston, MA 02111-1307, USA.  */
-
-/* As a special exception, when this file is copied by Bison into a
-   Bison output file, you may use that output file without restriction.
-   This special exception was added by the Free Software Foundation
-   in version 1.24 of Bison.  */
-
-/* Tokens.  */
-#ifndef YYTOKENTYPE
-# define YYTOKENTYPE
-   /* Put the tokens into the symbol table, so that GDB and other debuggers
-      know about them.  */
-   enum yytokentype {
-     LOADMODULE = 258,
-     TWODOTS = 259,
-     QSTRING = 260,
-     STRING = 261,
-     NUMBER = 262
-   };
-#endif
-#define LOADMODULE 258
-#define TWODOTS 259
-#define QSTRING 260
-#define STRING 261
-#define NUMBER 262
-
-
-
-
-#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
-#line 166 "ircd_parser.y"
-typedef union YYSTYPE {
-	int 		number;
-	char 		string[IRCD_BUFSIZE + 1];
-	conf_parm_t *	conf_parm;
-} YYSTYPE;
-/* Line 1240 of yacc.c.  */
-#line 57 "y.tab.h"
-# define yystype YYSTYPE /* obsolescent; will be withdrawn */
-# define YYSTYPE_IS_DECLARED 1
-# define YYSTYPE_IS_TRIVIAL 1
-#endif
-
-extern YYSTYPE yylval;
-
-
-
